<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_cpd;
	protected $obj_notify;
	protected $obj_upload;
	// variable definition
	protected $arr_params;
	protected $arr_id_files;
	protected $int_id_log;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		
	}		
	
	protected function ParseDocumentOutput(){
		/** Redirect result to default page */
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'isian');	
	}
	
	protected function PageLoad(){ 
		/* -- Other object loaded below */
		// cpd
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('kegiatan');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// --
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
		$this->obj_upload = $this->obj_ctrl->LoadLibrary('Uploader');
	}
	
	public function PageView(){
		// important to encypte bug post form
		if(isset($_POST['save'])){ 
			$action = array_keys($_POST['save']); 
			$this->arr_params = $_POST;
			unset($_POST);
		}else{
			$action = FALSE;
		}
		// controller to manage process that page requested
		switch($action[0]){
			case 'search':
				self::SearchData();
				break;
			case 'insert':
			self::InsertDataKegiatan();
				/*if(self::CheckPembayaranIuran()){
					
				}else{
					$this->obj_ctrl->RedirectPage($this->arr_routes['app'], 'iuran', 'info', 'pembayaran');	
				}*/
				break;
			default:
				break;
		}
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	// notification method
	private function SendNotification($err, $filled, $msg, $type){
		$this->obj_notify->ClearSession();
		$this->obj_notify->SetHeaderMessage($type, $msg);
		// error send
		foreach($err as $val){
			$this->obj_notify->SetMessage($val);
		}		
		// field value history
		for($i=0;$i<count($filled);$i++){
			$name = array_keys($filled);
			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);
		}
		$this->obj_notify->SentMessage();
	}
	
	// search method
	private function SearchData(){
		$_SESSION['search']['borang']['keyword'] = trim($this->arr_params['keyword']);
		$_SESSION['search']['borang']['ranah'] = $this->arr_params['ranah'];
		// $_SESSION['search']['borang']['jenis'] = $this->arr_params['jenis'];
	}
	
	// operation
	private function CheckPembayaranIuran(){			
		$thn = date('Y');
		$bln_now = date('n');
		if( $bln_now < 2){
			$smt = 'I';	
			$thn = $thn - 1;
		}elseif( $bln_now > 1  and  $bln_now <=7 ){
			$smt = 'II';
			$thn = $thn - 1;
		}else{
			$smt = 'I';
		}		
		$lunas = $this->obj_cpd->GetDataAsSingleArray("GetStatusPembayaranIuranByParams", array($thn, $smt, $this->str_userid));
		if(isset($lunas['status_pelunasan']) AND $lunas['status_pelunasan'] == 'yes')
			return true;
		else
			return false;
	}
	
	private function InsertDataKegiatan(){	
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// get id log
		$result = $this->obj_cpd->GetDataAsSingleArray("GetLastIdBukuLog", array());
		$this->int_id_log = $result['last'];
		// ----------------------------------------------------------------
		// Mendapatkan form aktif yang dipakai ----------------------------
		$params = array($this->arr_params['id_kegiatan']);
		$result = $this->obj_cpd->GetDataAsSingleArray("GetFormKegiatanByIdKegiatan", $params);
		$nama_kegiatan = $result['nama'];
		$int_id_form = $result['id_form'];
		// ----------------------------------------------------------------
		// Membuat data kegiatan ------------------------------------------
		$params = array($int_id_form);
		$rs_id = $this->obj_cpd->GetResourceId("GetDisplayedElemenByIdForm", $params);
		$data = '<?xml version="1.0" encoding="UTF-8" ?><data>';
		if($rs_id){
			while($rs = mysql_fetch_assoc($rs_id)){ 
				// required field
				if($rs['is_required'] == 'yes'){
					$err_msg = self::GetRequiredField($rs['id_elemen'], $rs['label'], $rs['tipe'], $this->arr_params);
					if(!empty($err_msg)){
						$err[] = $err_msg;
					}
				}
				// create item data
				$data .= self::GetParsedData($rs['id_elemen'], $rs['tipe'], $this->arr_params);
			}
		}
		$data .= '</data>';
		// ----------------------------------------------------------------
		// mendapatkan nilai skp dari skp engine --------------------------
		if($result['is_manual'] == 'yes'){
			$nilai = trim($this->arr_params['nilai_skp']);
			if(empty($nilai)){ $err[] = '<br /><strong>Nilai SKP</strong> tidak boleh kosong';}
		}else{
			$nilai = self::GetNilaiSKP($int_id_form, $this->arr_params['data']);
		}
		// ----------------------------------------------------------------
		// tanggal kegiatan -----------------------------------------------
		$tgl_kegiatan =  $this->arr_params['tahun_kegiatan'] . '-' . $this->arr_params['bulan_kegiatan'] . '-' . $this->arr_params['hari_kegiatan'];
		// ----------------------------------------------------------------	
		// required id kegiatan -------------------------------------------
		if(empty($this->arr_params['id_kegiatan'])){ $err[] = '<br /><strong>Id</strong> tidak boleh kosong'; }
		// ----------------------------------------------------------------	
		// Check Validasi -------------------------------------------------
		// periode
		$arr_check = $this->obj_cpd->GetDataAsSingleArray("CheckAllowedInputKegiatanByStr", array($tgl_kegiatan, $this->str_userid));
		if(empty($arr_check['id_periode'])){
			$err[] = '<br /><strong>Tanggal kegiatan</strong> yang anda masukkan tidak terdaftar dalam periode kegiatan PKB yang tercatat atau <br />periode kegiatan PKB yang anda daftarkan belum disetujui oleh Tim PKB';
		}else{
			$id_tahun = $this->obj_cpd->GetDataAsSingleArray("GetTahunKegiatanByParams", array($tgl_kegiatan, $arr_check['id_periode']));
			// status selesai
			if($arr_check['status_selesai'] == 'yes'){
				$err[] = '<br /><strong>Tanggal kegiatan</strong> yang anda masukkan berada dalam periode kegiatan PKB yang telah dinyatakan selesai oleh Komisi PKB';
			}
		}
		// ----------------------------------------------------------------
		// processing -----------------------------------------------------
		if(empty($err)){
			$params = array($this->int_id_log,$int_id_form,$this->str_userid, $data, $nilai, $tgl_kegiatan, $this->str_userid);
			// execute process
			if($this->obj_cpd->ProcessingRawData("InsertDataKegiatan", $params)){
				// upload file
				$err_file = self::UploadDokumenBukti($_FILES);
				$err = array_merge($err, $err_file);
				// notification message	
				$err[] = '<br />Nilai SKP yang diperoleh adalah <strong>'.$nilai.' SKP</strong>'; 
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// save history
				$history['user'] = $this->str_userid;
				$history['target'] = "member";
				$history['title'] = "Pencatatan kegiatan PKB";
				$history['deskripsi'] = $nama_kegiatan . ' ('.$nilai.' SKP)';
				$history['url_title'] = "Buku Log";
				$history['url_link'] = HTTPPATH . "index.php/private/cpd/buku-log/";
				$this->obj_cpd->AddActivitiesHistory($history);
				// update status tahun periode
				$params = array('no', 'waiting', $id_tahun['id_tahun_periode']);
				$this->obj_cpd->ProcessingRawData("UpdateStatusTahunPeriodeById", $params);
				// redirect to success page ------------------------------------
			}else{
				// filled last field
				$filled = array("LAST_INPUT" => $data, "TAHUN" => $this->arr_params['tahun_kegiatan'], 
				"BULAN" => $this->arr_params['bulan_kegiatan'], "DAY" => $this->arr_params['hari_kegiatan']);
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------	
			}
		}else{
			// filled last field
			$filled = array("LAST_INPUT" => $data, "TAHUN" => $this->arr_params['tahun_kegiatan'], 
			"BULAN" => $this->arr_params['bulan_kegiatan'], "DAY" => $this->arr_params['hari_kegiatan']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		}	
		// redirect page --------------------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'input', array($this->arr_params['id_kegiatan']));
	}
	
	private function UploadDokumenBukti($arr_file){
		$err = array();
		foreach($arr_file as $key => $file_data){
			if(!empty($file_data['tmp_name']) AND $file_data['size'] <= 300000){
				// allowed type
				$this->obj_upload->file_accept = array('doc', 'docx', 'xls', 'xlsx', 'pdf', 'ppt', 'zip', 'gif', 'jpeg', 'jpg', 'jpe', 'png', 'bmp', 'tiff', 'tif', 'txt', 'text', 'rtf', 'rtx', 'xsl', 'word', 'xl', 'log');
				// upload file
				if(isset($this->arr_id_files[$key]) AND !empty($this->arr_id_files[$key])){
					// name and path file
					$file_name = str_replace(' ', '_', $file_data['name']);
					$file_path = "doc/person/".$this->str_userid."/cpd/".$this->arr_id_files[$key]."/";
					// processing
					if($this->obj_upload->FileUpload($file_data, $file_path)){
						// insert to database
						$params = array($this->arr_id_files[$key], $this->int_id_log,$file_name, $file_path, $this->str_userid);
						$this->obj_cpd->ProcessingData("InsertDokumenBukti", $params);
						$err[] = '<br /><strong>'.$file_name.'</strong> berhasil diupload'; 
					}else{
						$err[] = '<br />'.$file_name.' <strong>tidak berhasil</strong> diupload'; 
					}
				}else{
					$err[] = '<br />'.$file_name.' <strong>tidak berhasil</strong> diupload'; 
				}				
			}else{
				$err[] = '<br />File <strong>tidak berhasil</strong> diupload'; 
			}
		}
		// return
		return $err;
	}
	
	private function GetRequiredField($id, $label, $tipe, $params){
		$err = "";
		switch($tipe){
			case 'text':				
				if(isset($params['data'][$id])){
					$value = trim($params['data'][$id]);
					if(empty($value))
						$err = '<br /><strong>'.$label.'</strong> tidak boleh kosong'; 
				}else{
					$err = '<br /><strong>'.$label.'</strong> tidak boleh kosong'; 
				}						
				break;
			case 'textarea':
				if(isset($params['data'][$id])){
					$value = trim($params['data'][$id]);
					if(empty($value))
						$err = '<br /><strong>'.$label.'</strong> tidak boleh kosong'; 
				}else{
					$err = '<br /><strong>'.$label.'</strong> tidak boleh kosong'; 
				}	
				break;
			case 'filebrowse':	
				if(isset($_FILES['data_' . $id])){
					if(empty($_FILES['data_' . $id]['name']))
						$err = '<br /><strong>'.$label.'</strong> tidak boleh kosong'; 
				}else{
					$err = '<br /><strong>'.$label.'</strong> tidak boleh kosong'; 
				}
				break;
			case 'radio':
				if(isset($params['data'][$id])){
					$value = trim($params['data'][$id]);
					if(empty($value))
						$err = '<br /><strong>'.$label.'</strong> tidak boleh kosong'; 
				}else{
					$err = '<br /><strong>'.$label.'</strong> tidak boleh kosong'; 
				}	
				break;
			case 'selectbox':
				if(isset($params['data'][$id])){
					$value = trim($params['data'][$id]);
					if(empty($value))
						$err = '<br /><strong>'.$label.'</strong> tidak boleh kosong'; 
				}else{
					$err = '<br /><strong>'.$label.'</strong> tidak boleh kosong'; 
				}	
				break;
			case 'date':				
				break;
			case 'datetime':				
				break;
			case 'spt_cabang':
				if(isset($params['data'][$id])){
					$value = trim($params['data'][$id]);
					if(empty($value))
						$err = '<br /><strong>'.$label.'</strong> tidak boleh kosong'; 
				}else{
					$err = '<br /><strong>'.$label.'</strong> tidak boleh kosong'; 
				}			
				break;	
			case 'spt_klinik':
				if(isset($params['data'][$id])){
					$value = trim($params['data'][$id]);
					if(empty($value))
						$err = '<br /><strong>'.$label.'</strong> tidak boleh kosong'; 
				}else{
					$err = '<br /><strong>'.$label.'</strong> tidak boleh kosong'; 
				}	
				break;	
			case 'spt_rumkit':
				if(isset($params['data'][$id])){
					$value = trim($params['data'][$id]);
					if(empty($value))
						$err = '<br /><strong>'.$label.'</strong> tidak boleh kosong'; 
				}else{
					$err = '<br /><strong>'.$label.'</strong> tidak boleh kosong'; 
				}	
				break;	
			case 'spt_studi':
				if(isset($params['data'][$id])){
					$value = trim($params['data'][$id]);
					if(empty($value))
						$err = '<br /><strong>'.$label.'</strong> tidak boleh kosong'; 
				}else{
					$err = '<br /><strong>'.$label.'</strong> tidak boleh kosong'; 
				}	
				break;	
			case 'spt_wilayah':
				if(isset($params['data'][$id])){
					$value = trim($params['data'][$id]);
					if(empty($value))
						$err = '<br /><strong>'.$label.'</strong> tidak boleh kosong'; 
				}else{
					$err = '<br /><strong>'.$label.'</strong> tidak boleh kosong'; 
				}	
				break;
			default:
				break;
		}
		return $err;
	}
	
	private function GetParsedData($tag, $tipe, $params){
		$data = "<item>";
		$data .= "<idt>";
		$data .= $tag;
		$data .= "</idt>";
		$data .= "<value>";
		$value = "";
		switch($tipe){
			case 'text':
				if(isset($params['data'][$tag])){
					$value = $params['data'][$tag];
				}				
				break;
			case 'textarea':
				if(isset($params['data'][$tag])){
					$value = $params['data'][$tag];
				}
				break;
			case 'filebrowse':
				if(isset($_FILES['data_' . $tag])){
					// get id dokumen bukti (upload)
					$arr_result = $this->obj_cpd->GetDataAsSingleArray("GetLastIdDokumenBukti", array());
					$this->arr_id_files['data_' . $tag] = $arr_result['last'];
					$value = $this->arr_id_files['data_' . $tag];
				}
				break;
			case 'radio':
				if(isset($params['data'][$tag])){
					$value = $params['data'][$tag];
				}
				break;
			case 'selectbox':
				if(isset($params['data'][$tag])){
					$value = $params['data'][$tag];
				}
				break;
			case 'date':
				$value = $params["tahun_".$tag] . '-' . $params["bulan_".$tag] . '-' . $params["day_".$tag];
				break;
			case 'datetime':
				$value = $params["tahun_".$tag] . '-' . $params["bulan_".$tag] . '-' . $params["day_".$tag] . ' ' . $params["hour_".$tag] . ':' . $params["minute_".$tag] . ':00';
				break;
			case 'spt_cabang':
				if(isset($params['data'][$tag])){
					$value = $params['data'][$tag];
				}		
				break;	
			case 'spt_klinik':
				if(isset($params['data'][$tag])){
					$value = $params['data'][$tag];
				}
				break;	
			case 'spt_rumkit':
				if(isset($params['data'][$tag])){
					$value = $params['data'][$tag];
				}
				break;	
			case 'spt_studi':
				if(isset($params['data'][$tag])){
					$value = $params['data'][$tag];
				}
				break;	
			case 'spt_wilayah':
				if(isset($params['data'][$tag])){
					$value = $params['data'][$tag];
				}
				break;
			default:
				break;
		}
		$value = htmlspecialchars($value, ENT_QUOTES);
		$data .= $value;
		$data .= "</value>";
		$data .= "</item>";
		return $data;
	}
	
	private function GetNilaiSKP($form, $params){
		$nilai = 0;
		$group_list = "";
		$sp = "";
		// get elemen parameter
		$rs_id = $this->obj_cpd->GetResourceId("GetElemenParameterByIdForm", array($form));
		if($rs_id){
			while($rs = mysql_fetch_assoc($rs_id)){
				switch($rs['formulation']){
					case 'range':
						// get list elemen
						$rs_id_list = $this->obj_cpd->GetResourceId("GetElemenListByEngine", array($rs['related_engine']));
						if($rs_id_list){
							$list = $sp . "FIND_IN_SET(0, group_elemen_list)";
							while($rec = mysql_fetch_assoc($rs_id_list)){
								$range_value = explode('-', $rec['list_value'], 2);
								if(sizeof($range_value) >= 2){
									$batas_bawah = round($range_value[0], 2);
									$batas_atas = round($range_value[1], 2);
								}else{
									$batas_bawah = 0;
									$batas_atas = 0;
								}								
								if($params[$rs['id_elemen']] >= $batas_bawah AND $params[$rs['id_elemen']] <= $batas_atas){
									$list =  $sp . "FIND_IN_SET(".$rec['id_list'].", group_elemen_list)";
									break;
								}
							}
							$group_list .= $list;	
							$sp = " AND ";	
						}	
						break;
					case 'direct':
						if(isset($params[$rs['id_elemen']])){
							$arr_result = $this->obj_cpd->GetDataAsSingleArray("GetElemenIndikatorByDirect", array($rs['related_engine'], $params[$rs['id_elemen']]));					
							$list = $arr_result['id_list'];
							$group_list .= $sp . "FIND_IN_SET(".$list.", group_elemen_list)";			
							$sp = " AND ";		
						}
						break;
					default :
						break;
				}
			}
		}
		// use default value if not exists
		if(!empty($group_list)){
			// match on library
			$arr_result = $this->obj_cpd->GetDataAsSingleArray("GetNilaiSkpByEngine", array($group_list));
			if(isset($arr_result['nilai_skp'])){$nilai = $arr_result['nilai_skp'];}
		}else{		
			$arr_result = $this->obj_cpd->GetDataAsSingleArray("GetNilaiSkpByDefault", array($form));
			$nilai = $arr_result['default_point'];
		}
		return $nilai;
	}
	
}

?>