<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_cpd;
	protected $obj_date;
	protected $obj_paging;
	// variable definition
	protected $arr_search;
	protected $int_periode;
	protected $int_tahun;
	protected $str_tgl_mulai;
	protected $str_tgl_selesai;
	protected $arr_field;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		/* -- Other object loaded below */
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('kegiatan');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// --
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');
	}
	
	public function PageView(){	
		// select periode aktif
		self::GetVariableBukuLog();
		// display periode buku log
		self::DisplayPeriodeBukuLog();
		// display detail Kegiatan
		self::DisplayDetailKegiatan();
		// display List Kegiatan
		self::DisplayListKegiatan();
		// Variable
		self::DisplayVariable();	
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayVariable(){
		// variable
		$this->obj_tmpl->addVar('content', 'URL_STR', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'periode'));
		$this->obj_tmpl->addVar('content', 'URL_LIST', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'log'));
		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		$this->obj_tmpl->addVar('content', 'URL_REMOTEDATA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], 'borang', 'ajax-keyword'));
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));
		// tahun periode str
		$this->obj_tmpl->addVar('content', 'URL_PERIODE', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'log', array($this->int_periode, $this->int_tahun)));
		// --
		$this->obj_tmpl->addVar('content', 'URL_BORANG', $this->obj_ctrl->GetUrl($this->arr_routes['app'], 'cpd', 'borang', 'isian'));
		$this->obj_tmpl->addVar('content', 'URL_DASHBOARD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], 'dashboard', 'pribadi', 'p2kb', array($this->int_periode)));
		// --
		$this->obj_tmpl->addVar('content', 'PERIODE', $this->int_periode);
		$this->obj_tmpl->addVar('content', 'TAHUN', $this->int_tahun);
	}
	
	private function GetVariableBukuLog(){
		$str_default_periode = date('Y') . '-' . date('m') . '-' . date('d');
		// default periode 
		$result = $this->obj_cpd->GetDataAsSingleArray("GetDefaultPeriodeByPerson", array($this->str_userid, $str_default_periode));		
		// cari periodenya
		if(isset($this->arr_routes['params'][0]) AND !empty($this->arr_routes['params'][0])){
			// int periode
			$this->int_periode = $this->arr_routes['params'][0];
		}else{	
			// int periode
			$this->int_periode = $result['id_periode'];
		}
		// cari tahun kegiatan yang aktif berdasarkan periode
		if(isset($this->arr_routes['params'][1]) AND !empty($this->arr_routes['params'][1])){
			// int tahun
			$this->int_tahun = $this->arr_routes['params'][1];
			$result_tahun = $this->obj_cpd->GetDataAsSingleArray("GetDetailPeriodeKegiatanBySelected", array($this->str_userid, $this->int_tahun));		
			// set batasan tanggal
			$this->str_tgl_mulai = $result_tahun['tgl_mulai'];
			$this->str_tgl_selesai = $result_tahun['tgl_selesai'];
		}else{
			// int tahun
			$this->int_tahun = $result['id_tahun_periode'];
			$this->str_tgl_mulai = $result['tgl_mulai'];
			$this->str_tgl_selesai = $result['tgl_selesai'];
		}
	}
	
	private function DisplayPeriodeBukuLog(){
		// display detail periode
		$rs_str = $this->obj_cpd->GetDataAsSingleArray("GetDetailPeriodeStrById", array($this->str_userid, $this->int_periode));
		$this->obj_tmpl->addVar('content', 'TAHUN_STR', $rs_str['mulai'] . ' - ' . $rs_str['selesai']);
		switch($rs_str['status_evaluasi']){
			case 'rejected':
				$status_verifikasi = '<img src="'.HTTPPATH."doc/temp/redin-ico.jpg".'" title="Rejected" />';
				break;
			case 'accepted':
				$status_verifikasi = '<img src="'.HTTPPATH."doc/temp/greedin-ico.jpg".'" title="Accepted" />';
				break;
			default :
				$status_verifikasi = '<img src="'.HTTPPATH."doc/temp/orangin-ico.jpg".'" title="Waiting" />';
				break;
		}
		$this->obj_tmpl->addVar('content', 'VERIFIKASI_STR', $status_verifikasi);
		if($rs_str['status_pengajuan'] == 'yes')
			$this->obj_tmpl->addVar('content', 'PENGAJUAN_STR', '<img src="'.HTTPPATH."doc/temp/greedin-ico.jpg".'" />');
		else
			$this->obj_tmpl->addVar('content', 'PENGAJUAN_STR', '<img src="'.HTTPPATH."doc/temp/redin-ico.jpg".'" />');
		// diaplay tahun kegiatan
		$rs_id =  $this->obj_cpd->GetResourceId("GetListTahunPeriodeById", array($this->str_userid, $this->int_periode));
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				$this->obj_tmpl->addVar('list_tahun', 'VALUE', $this->int_periode . '/' .$rec['id_tahun_periode'] . '/' . $this->arr_routes['params'][2] . '/');
				// parse data
				$lbl= $this->obj_date->GetFullDate($rec['tgl_mulai']).' s/d '.$this->obj_date->GetFullDate($rec['tgl_selesai']);
				if($this->int_tahun == $rec['id_tahun_periode']){
					$this->obj_tmpl->addVar('list_tahun', 'SELECTED', 'selected="selected"');
					// selected tahun kegiatan
					$this->obj_tmpl->addVar('content', 'TAHUN_PERIODE', $lbl);
					// end of selected
				}else{
					$this->obj_tmpl->addVar('list_tahun', 'SELECTED', '');
				}
				$this->obj_tmpl->addVar('list_tahun', 'TAHUN', $rec['tahun'] . '/' . ($rec['tahun'] + 1));
				$this->obj_tmpl->ParseTemplate('list_tahun', 'a');
			}
		}
	}
	
	private function DisplayListKegiatan(){
		$no = 1;
		$total = 0;
		// parameter
		$params = array($this->str_userid, $this->arr_routes['params'][2], $this->str_tgl_mulai, $this->str_tgl_selesai);
		// get data
		//$this->obj_cpd->debugquery("GetBukuLogByIdKegiatan", $params);
		$rs_id = $this->obj_cpd->GetResourceId("GetBukuLogByIdKegiatan", $params);
		// parse data
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				// tanggal
				$this->obj_tmpl->addVar('list_kegiatan', 'DATE_LABEL', $rec['date_label']);
				// url
				$url_edit = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($this->int_periode, $this->int_tahun, $rec['id_kegiatan'], $rec['id_log']));
				$url_hapus = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'hapus', array($this->int_periode, $this->int_tahun, $rec['id_kegiatan'], $rec['id_log']));
				$this->obj_tmpl->addVar('list_kegiatan', 'URL_EDIT', $url_edit);
				$this->obj_tmpl->addVar('list_kegiatan', 'URL_HAPUS', $url_hapus);
				// parse nilai
				$this->obj_tmpl->addVar('list_kegiatan', 'NO', $no . '.');
				if($rec['tipe'] == 'rutin'){
					$this->obj_tmpl->addVar('list_kegiatan', 'NILAI', '-');
					if(empty($total)){
						$total = self::GetNilaiSkpRutin($rec['id_form']);
					}
				}else{
					$total = $total + $rec['nilai_skp'];
					$this->obj_tmpl->addVar('list_kegiatan', 'NILAI', $rec['nilai_skp']);
				}
				// parse data
				$data = self::ParsingDataKegiatan($rec['id_log'], $rec['id_form'], $rec['data_kegiatan']);
				$this->obj_tmpl->addVar('list_kegiatan', 'DATA', $data);
				// ---
				$this->obj_tmpl->addVar('list_kegiatan', 'TANGGAL', $this->obj_date->GetFullDate($rec['tanggal_kegiatan']));
				$this->obj_tmpl->addVar('list_kegiatan', 'TGL_PERIKSA', $this->obj_date->GetFullDate($rec['tgl_verifikasi']));
				$this->obj_tmpl->addVar('list_kegiatan', 'PEMERIKSA', self::GetDataPemeriksa($rec['verifikator']));
				$this->obj_tmpl->addVar('list_kegiatan', 'CATATAN', $rec['catatan']);
				$this->obj_tmpl->addVar('list_kegiatan', 'CATATAN_KOMISI', $rec['catatan_komisi']);
				switch($rec['evaluated']){
					case 'no':
						$status_verifikasi = '<img src="'.HTTPPATH."doc/temp/redin-ico.jpg".'" title="Rejected" />';
						$this->obj_tmpl->addVar('list_kegiatan', 'LABEL_VERIFIKASI', 'Di tolak');
						break;
					case 'yes':
						$status_verifikasi = '<img src="'.HTTPPATH."doc/temp/greedin-ico.jpg".'" title="Accepted" />';
						$this->obj_tmpl->addVar('list_kegiatan', 'LABEL_VERIFIKASI', 'Telah diperiksa');
						break;
					default :
						$status_verifikasi = '<img src="'.HTTPPATH."doc/temp/orangin-ico.jpg".'" title="Waiting" />';
						$this->obj_tmpl->addVar('list_kegiatan', 'LABEL_VERIFIKASI', 'Menunggu hasil pemeriksaan');
						break;
				}
				$this->obj_tmpl->addVar('list_kegiatan', 'VERIFIKASI', $status_verifikasi);
				$this->obj_tmpl->ParseTemplate('list_kegiatan', 'a');
				$no++;	
			}
		}		
		$this->obj_tmpl->addVar('content', 'TOTAL_NILAI', $total);
		$this->obj_tmpl->addVar('content', 'JUMLAH_KEGIATAN', $no - 1);
	}
	
	private function ParsingDataKegiatan($id_log, $id_form, $data){
		$new_parse = "<table width=\"100%\">";
		// field
		if(isset($data)){
			$strxml = $data;			
			$xml = simplexml_load_string($strxml);
			// echo does the casting for you
			$count = count($xml->item);
			for($i=0;$i<$count;$i++){
				$id = intval($xml->item[$i]->idt);
				$value = strval($xml->item[$i]->value);
				$this->arr_field[$id] = $value;
			}
		}	
		// parsing
		$rs_id = $this->obj_cpd->GetResourceId("GetDisplayedElemenByIdForm", array($id_form));
		if($rs_id){
			while($rs = mysql_fetch_assoc($rs_id)){	
				if(!isset($this->arr_field[$rs['id_elemen']])){ $this->arr_field[$rs['id_elemen']] = "";}
				$new_parse .= "<tr>";		
				$new_parse .= "<td width=\"30%\">" . $rs['label'] . "</td>";
				if($rs['tipe'] != 'filebrowse'){
					$new_parse .= "<td width=\"70%\">" . $this->arr_field[$rs['id_elemen']] . "</td>";
				}else{
					// url
					$url = "#";
					// get file dokumen
					$params = array($this->str_userid, $this->arr_field[$rs['id_elemen']]);
					//$this->obj_cpd->debugquery("GetDetailedDokumenBukti", $params);
					$arr_data = $this->obj_cpd->GetDataAsSingleArray("GetDetailedDokumenBukti", $params);
					if(!empty($arr_data)){
						$file = $arr_data['file_path'] . $arr_data['file_name'];
						if(!is_file($file)){
							$arr_data['file_name'] = "File not found";
						}else{
							// url
							$url = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], 'dokumen', 'download', array(sha1(md5($this->str_userid)), md5(sha1($this->arr_field[$rs['id_elemen']]))));
							

						}					
						//-
						$new_parse .= "<td width=\"70%\"><a href=\"$url\">" . $arr_data['file_name'] . "</a></td>";
					}else{
						$new_parse .= "<td width=\"70%\"></td>";
					}			
				}			
				$new_parse .= "</tr>";	
			}
		}		
		$new_parse .= "</table>";
		return $new_parse;
	}
	
	private function GetNilaiSkpRutin($id_form){
		$nilai = 0;
		$jumlah = 0;
		// get parameter and indikator
		$arr = $this->obj_cpd->GetDataAsSingleArray("GetParameterAndEngineByForm", array($id_form, $id_form));
		$id_parameter = $arr['parameter'];
		$id_engine = $arr['indikator'];
		// get nilai dalam range tahun kegiatannya
		$rs_id = $this->obj_cpd->GetResourceId("GetDataKegiatanByFormDate", array($this->str_userid, $id_form, $this->str_tgl_mulai, $this->str_tgl_selesai));
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				$arr_field = "";
				$xml = simplexml_load_string($rec["data_kegiatan"]);
				// echo does the casting for you
				$count = count($xml->item);
				for($i=0;$i<$count;$i++){
					$id = intval($xml->item[$i]->idt);
					$value = strval($xml->item[$i]->value);
					if($id == $id_parameter){
						$jumlah = $jumlah + $value;
						break;
					}
				}
			}
		}
		// get list elemen
		$rs_id_list = $this->obj_cpd->GetResourceId("GetElemenListByEngine", array($id_engine));
		if($rs_id_list){
			$group_list = "FIND_IN_SET(0, group_elemen_list)";
			while($rec = mysql_fetch_assoc($rs_id_list)){
				$range_value = explode('-', $rec['list_value'], 2);
				if(sizeof($range_value) >= 2){
					$batas_bawah = round($range_value[0], 2);
					$batas_atas = round($range_value[1], 2);
				}else{
					$batas_bawah = 0;
					$batas_atas = 0;
				}	
				if($jumlah >= $batas_bawah AND $jumlah <= $batas_atas){
					$group_list = "FIND_IN_SET(".$rec['id_list'].", group_elemen_list)";
					break;
				}
			}
		}
		$nilai = $this->obj_cpd->GetDataAsSingleArray("GetNilaiSkpByEngine", array($group_list));	
		if(!empty($nilai))
			return $nilai['nilai_skp'];
		else
			return 0;
	}
	
	private function DisplayDetailKegiatan(){
		$params = array($this->arr_routes['params'][2]);
		$rs = $this->obj_cpd->GetDataAsSingleArray("GetDetailKegiatanByIdKegiatan", $params);
		$this->obj_tmpl->addVar('content', 'NAMA_KEGIATAN', $rs['nama']);
		if(empty($rs['batas_atas']))
			$this->obj_tmpl->addVar('content', 'BATASAN_SKP', '-');
		else
			$this->obj_tmpl->addVar('content', 'BATASAN_SKP', $rs['batas_atas'] . ' skp');
	}
	
	private function GetDataPemeriksa($person){
		$rs = $this->obj_cpd->GetDataAsSingleArray("GetDataPemeriksaByPerson", array($person));
		if(!empty($rs)){
			$label = $rs['prefix'].' '.$rs['nama_lengkap'].' '.$rs['suffix'].'<br>Tim PKB '.$rs['nama'];
		}else{
			$label = "-";
		}
		return $label;
	}
}

?>