<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_cpd;
	protected $obj_date;
	// variable
	protected $int_periode = 0;	
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		// load business
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('catatan');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// --
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	
	}
	
	public function PageView(){
		// Display page link
		self::DisplayPageLink();
		// Display list periode
		self::DisplayListPeriode();
		// Display list dokumen
		self::DisplayListData();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayPageLink(){
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'komisi-p2kb'));
	}
	
	private function DisplayListPeriode(){
		if(isset($this->arr_routes['params'][0]) AND !empty($this->arr_routes['params'][0])){
			$this->int_periode = $this->arr_routes['params'][0];
		}
		$rs_id = $this->obj_cpd->GetResourceId("GetListPeriodeByPerson", array($this->str_userid));
		if($rs_id){
			$temp = "";
			while($rec = mysql_fetch_assoc($rs_id)){
				if(empty($tmp) AND empty($this->int_periode)){ $this->int_periode = $rec['id_periode']; $tmp = true;}
				// selected
				if($rec['id_periode'] == $this->int_periode)
					$this->obj_tmpl->addVar('list_periode', 'SELECTED', 'selected="selected"');	
				else
					$this->obj_tmpl->addVar('list_periode', 'SELECTED', '');				
				// parse
				$this->obj_tmpl->addVar('list_periode', 'VALUE', $rec['id_periode']);	
				$label = $this->obj_date->GetFullDate($rec['tgl_mulai'], 'ins') .' s/d '. $this->obj_date->GetFullDate($rec['tgl_selesai'], 'ins');
				$this->obj_tmpl->addVar('list_periode', 'LABEL', $label);	
				$this->obj_tmpl->parseTemplate('list_periode', 'a');	
			}
		}else{
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], 'rencana', 'diri');
		}
	}
	
	private function DisplayListData(){
		$this->obj_tmpl->addVar('content', 'TOTAL_CATATAN', 0);
		$rs_id = $this->obj_cpd->GetResourceId("GetListCatatanByPerson", array($this->str_userid, $this->int_periode));
		if($rs_id){
			$no = 1;
			while($rec = mysql_fetch_assoc($rs_id)){				
				$this->obj_tmpl->addVar('list_data', 'NO', $no);
				$this->obj_tmpl->addVar('list_data', 'JUDUL', $rec['judul']);	
				$this->obj_tmpl->addVar('list_data', 'DESKRIPSI', $rec['keterangan']);
				$this->obj_tmpl->addVar('list_data', 'PEMERIKSA', self::GetDataPengirim($rec['mdb']));	
				$this->obj_tmpl->addVar('list_data', 'TANGGAL', $this->obj_date->GetShortDate($rec['mdd'], 'in'));					
				$this->obj_tmpl->parseTemplate('list_data', 'a');	
				$no++;
			}
			$this->obj_tmpl->addVar('content', 'TOTAL_CATATAN', $no - 1);
		}
	}
	
	private function GetDataPengirim($person){
		$rs = $this->obj_cpd->GetDatasetAsArray("GetDataPemeriksaByPerson", array($person));
		if(!empty($rs)){
			$label = $rs[0]['prefix'] . ' ' . $rs[0]['nama_lengkap'] . ' ' . $rs[0]['suffix'];
		}else{
			$label = "-";
		}
		return $label;
	}
}

?>