<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_dok;
	protected $obj_date;
	protected $obj_notify;
	// var
	protected $int_periode;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		// load business
		$this->obj_dok = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('dokumen');
		$this->obj_dok->SetUsesQuery($loaded_query);
		// --
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');		
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');	
		// javascript loaded
		$this->obj_ctrl->LoadJavascript('dhtmlgoodies_calendar');
		// dhtmlgoodies_calendar loaded
		$this->obj_ctrl->LoadStyle('dhtmlgoodies_calendar', 'dhtmlgoodies_calendar');
		// dhtmlgoodies_calendar loaded body event
		$this->obj_ctrl->LoadEventOnBody("onload", "SetDhtmlgoodiesPathImages('".HTTPPATH."application/themes/dhtmlgoodies_calendar/img/');");		
	}
	
	public function PageView(){
		// display test cookies
		self::DisplayNotification();
		// display variable
		self::DisplayVariable();
		// display data
		self::DisplayData();
		// display periode
		self::DisplayListPeriode();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayNotification(){
		// get session for start notification
		$this->obj_notify->GetMessage();
		// display message	
		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');
		// display last filled	
		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'display');
		// clear session when finish
		$this->obj_notify->ClearSession();
	}
	
	private function DisplayVariable(){
		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'bukti'));
	}
	
	private function DisplayData(){
		if(isset($this->arr_routes['params'][0])){
			$this->obj_tmpl->addVar('content', 'ID', $this->arr_routes['params'][0]);
			// get data		
			$result = $this->obj_dok->GetDataAsSingleArray("GetDetailDokumenByPerson", array($this->str_userid, $this->arr_routes['params'][0]));
			$this->int_periode = $result['id_periode'];
			// crypt id	
			//$url_download = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'download-lampiran', array(sha1(md5($this->str_userid)), md5(sha1($result['id']))));
			$url_download = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'download-lampiran', array($this->str_userid, $result['id']));
			// parse data
			if(!isset($this->obj_notify->arr_message['field'])){
			if(!empty($result)){
			$this->obj_tmpl->addVar('content', 'URL_DOWNLOAD', $url_download);	
			//$this->obj_tmpl->addVar('content', 'JUDUL', $result['judul']);	
			$this->obj_tmpl->addVar('content', 'DESKRIPSI', $result['deskripsi']);	
			$this->obj_tmpl->addVar('content', 'FILENAME', $result['file_name']);
			$this->obj_tmpl->addVar('content', strtoupper($result['judul']), 'selected="selected"');
			}
			}	
			// tanggal 
			$tgl_split = explode('-', $result['tgl_dokumen']);
			$this->obj_date->SetPatTemplates($this->obj_tmpl);
			$this->obj_date->DhtmlgoodiesStandardDate('list_year', 'list_month', 'list_day', $tgl_split[0] , $tgl_split[1], $tgl_split[2], date('Y') - 10, date('Y'));
		}else{
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'bukti');
		}
	}
	
	private function DisplayListPeriode(){
		$rs_id = $this->obj_dok->GetResourceId("GetListPeriodeByPerson", array($this->str_userid));
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				// selected
				if($rec['id_periode'] == $this->int_periode)
					$this->obj_tmpl->addVar('list_periode', 'SELECTED', 'selected="selected"');	
				else
					$this->obj_tmpl->addVar('list_periode', 'SELECTED', '');
				// data
				$this->obj_tmpl->addVar('list_periode', 'VALUE', $rec['id_periode']);	
				$label = $this->obj_date->GetFullDate($rec['tgl_mulai'], 'ins') .' s/d '. $this->obj_date->GetFullDate($rec['tgl_selesai'], 'ins');
				$this->obj_tmpl->addVar('list_periode', 'LABEL', $label);	
				$this->obj_tmpl->parseTemplate('list_periode', 'a');	
			}
		}
	}
}

?>