<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{		
	protected $obj_cpd;
	protected $obj_date;
	// variable definition
	protected $int_periode = '';
	protected $str_tgl_mulai;
	protected $str_tgl_selesai;
	protected $arr_ranah_all = array();
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		/* Other object loaded below */
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('evaluasi', 'kegiatan', 'str');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// --
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	
	}
	
	public function PageView(){
		// display detail user
		self::DisplayDetailPerson();
		// display periode user
		self::DisplayListPeriode();
		// display tahun kegiatan
		self::GetListTahunKegiatan();
		// display keseluruhan
		self::DisplayTabelNilaiSKP();
		// display variable
		self::DisplayVariable();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayVariable(){
		// process link
		$this->obj_tmpl->addVar('display', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		// 
		if(!empty($this->int_periode)){
			$this->obj_tmpl->addVar('display', 'view', 'data');
			// sub link
			$this->obj_tmpl->addVar('content', 'URL_REKAPITULASI', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'evaluasi', array($this->int_periode)));
			$this->obj_tmpl->addVar('content', 'URL_PENILAIAN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'penilaian', array($this->int_periode)));
			$this->obj_tmpl->addVar('content', 'URL_PKB', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'p2kb', array($this->int_periode)));
			$this->obj_tmpl->addVar('content', 'URL_SURAT', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'rekomendasi', array($this->int_periode)));
		}else{
			// sub link
			$this->obj_tmpl->addVar('content', 'URL_REKAPITULASI', '#');
			$this->obj_tmpl->addVar('content', 'URL_PENILAIAN', '#');
			$this->obj_tmpl->addVar('content', 'URL_PKB', '#');
			$this->obj_tmpl->addVar('content', 'URL_SURAT', '#');
		}
	}
	
	private function DisplayDetailPerson(){
		$result = $this->obj_cpd->GetDataAsSingleArray("GetDetailAnggotaByIdPerson", array($this->str_userid));
		if(!empty($result)){			
			$this->obj_tmpl->addVar('content', 'PREFIX', $result['prefix']);
			$this->obj_tmpl->addVar('content', 'SUFFIX', $result['suffix']);
			$this->obj_tmpl->addVar('content', 'NAMA', $result['nama_lengkap']);
			$this->obj_tmpl->addVar('content', 'ALAMAT', $result['alamat']);
			$this->obj_tmpl->addVar('content', 'KOTA', $result['kota']);
			$this->obj_tmpl->addVar('content', 'CABANG', $result['cabang']);
			$this->obj_tmpl->addVar('content', 'NO_ANGGOTA', $result['no_anggota']);
			// display foto
			$path = "doc/person/".$result['id_person']."/foto/".$result['photo'];
			if(is_file($path))
				$this->obj_tmpl->addVar('content', 'FOTO', $path);
			else
				$this->obj_tmpl->addVar('content', 'FOTO', "doc/temp/blank.jpg");
		}
	}
	
	private function DisplayListPeriode(){
		// link
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));
		// list tahun
		$id_selected = '';
		if(isset($this->arr_routes['params'][0])){ 
			$id_selected = $this->arr_routes['params'][0];
		}
		// variable
		$rs_id = $this->obj_cpd->GetResourceId("GetListPeriodeStrByIdPerson", array($this->str_userid));
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				if($id_selected == $rec['id_periode']){
					// --
					$this->int_periode = $rec['id_periode'];
					$mulai = $this->obj_date->GetFullDate($rec['tgl_mulai'], 'ins');
					$selesai = $this->obj_date->GetFullDate($rec['tgl_selesai'], 'ins');
					$this->obj_tmpl->addVar('display', 'PERIODE_STR', $mulai.' s/d '.$selesai);
					// --
					$this->obj_tmpl->addVar('list_periode', 'SELECTED', 'selected="selected"');
				}else{
					$this->obj_tmpl->addVar('list_periode', 'SELECTED', '');
				}
				$this->obj_tmpl->addVar('list_periode', 'VALUE', $rec['id_periode']);
				$this->obj_tmpl->addVar('list_periode', 'TGL_MULAI', $this->obj_date->GetFullDate($rec['tgl_mulai'], 'ins'));
				$this->obj_tmpl->addVar('list_periode', 'TGL_SELESAI', $this->obj_date->GetFullDate($rec['tgl_selesai'], 'ins'));
				$this->obj_tmpl->ParseTemplate('list_periode', 'a');
			}
		}
		$this->obj_tmpl->addVar('display', 'ID_PERIODE', $this->int_periode);
	}
	
	// get nilai
	
	private function GetListTahunKegiatan(){
		$skp_total = 0;
		$formulas = 250 / 150;
		// get tgl mulai dan tgl selesai
		$rs_id = $this->obj_cpd->GetResourceId("GetListPeriodeKegiatanById", array($this->int_periode, $this->str_userid));
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				// get nilai per tahun
				// get nilai by params 
				$nilai = self::GetNilaiByTanggal($this->str_userid, $rec['tgl_mulai'], $rec['tgl_selesai']);
				$skp_total = $skp_total + $nilai;
				// --
				$this->obj_tmpl->addVar('list_tahun', 'URL_DETAIL', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'penilaian', array($this->int_periode, $rec['id_tahun_periode'])));
				$this->obj_tmpl->addVar('list_tahun', 'ID', $rec['id_tahun_periode']);
				$this->obj_tmpl->addVar('list_tahun', 'TGL_MULAI', $this->obj_date->GetFullDate($rec['tgl_mulai'], 'ins'));
				$this->obj_tmpl->addVar('list_tahun', 'TGL_SELESAI', $this->obj_date->GetFullDate($rec['tgl_selesai'], 'ins'));
				switch($rec['status_pengajuan']){
					case 'yes':
						$this->obj_tmpl->addVar('list_tahun', 'PENGAJUAN', 'greedin-ico.jpg');
						$this->obj_tmpl->addVar('list_tahun', 'CHECKED', 'checked="checked"');
						break;
					default :
						$this->obj_tmpl->addVar('list_tahun', 'PENGAJUAN', 'orangin-ico.jpg');
					 	break;
				}
				switch($rec['status_evaluasi']){
					case 'accepted':
						$this->obj_tmpl->addVar('list_tahun', 'EVALUASI', 'greedin-ico.jpg');
						break;
					case 'rejected':
						$this->obj_tmpl->addVar('list_tahun', 'EVALUASI', 'redin-ico.jpg');
						break;
					default :
						$this->obj_tmpl->addVar('list_tahun', 'EVALUASI', 'orangin-ico.jpg');
					 	break;
				}
				// total skp Persatuan Perawat Nasional Indonesia
				$skp_ikafmi = number_format($nilai, 2, ',', '');
				$this->obj_tmpl->addVar('list_tahun', 'TOTAL', $skp_ikafmi);
				// total skp konversi
				$skp_konversi = $nilai * $formulas;
				$skp_konversi = number_format($skp_konversi, 2, ',', '');
				$this->obj_tmpl->addVar('list_tahun', 'TOTAL_KONVERSI', $skp_konversi);
				// append
				$this->obj_tmpl->ParseTemplate('list_tahun', 'a');
			}
		}
		$skp_ikafmi_total = number_format($skp_total, 2, ',', '');
		$this->obj_tmpl->addVar('display', 'TOTAL_PERTAHUN_ALL', $skp_ikafmi_total);
		$skp_konversi_total = $skp_total * $formulas;
		$skp_konversi_total = number_format($skp_konversi_total, 2, ',', '');
		$this->obj_tmpl->addVar('display', 'TOTAL_PERTAHUN_KONVERSI', $skp_konversi_total);
	}
	
	private function GetNilaiByTanggal($id_person, $str_tgl_mulai, $str_tgl_selesai){
		$total = 0;
		// parameter
		$params = array($id_person, $str_tgl_mulai, $str_tgl_selesai);
		// get data
		$rs_id = $this->obj_cpd->GetResourceId("GetEvaluatedPKBGroupByForm", $params);
		// parse data
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				// set ranah
				if(!isset($this->arr_ranah_all[$rec['ranah']])){$this->arr_ranah_all[$rec['ranah']] = '';}
				// get nilai skp
				if($rec['tipe'] == 'rutin')
					$nilai = self::GetNilaiSkpRutin($id_person, $rec['id_form'], $str_tgl_mulai, $str_tgl_selesai);
				else
					$nilai = $rec['nilai'];
				// tabel by ranah
				$this->arr_ranah_all[$rec['ranah']] = $this->arr_ranah_all[$rec['ranah']] + $nilai;		
				$total = $total + $nilai;
			}
		}
		return $total;
	}
	
	private function GetNilaiSkpRutin($id_person, $id_form, $str_tgl_mulai, $str_tgl_selesai){
		$nilai = 0;
		$jumlah = 0;
		// get parameter and indikator
		$arr = $this->obj_cpd->GetDataAsSingleArray("GetParameterAndEngineByForm", array($id_form, $id_form));
		$id_parameter = $arr['parameter'];
		$id_engine = $arr['indikator'];
		// get nilai dalam range tahun kegiatannya
		$rs_id = $this->obj_cpd->GetResourceId("GetDataKegiatanByFormDate", array($id_person, $id_form, $str_tgl_mulai, $str_tgl_selesai));
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				$arr_field = "";
				$xml = simplexml_load_string($rec["data_kegiatan"]);
				// echo does the casting for you
				$count = count($xml->item);
				for($i=0;$i<$count;$i++){
					$id = intval($xml->item[$i]->idt);
					$value = strval($xml->item[$i]->value);
					if($id == $id_parameter){
						$jumlah = $jumlah + $value;
						break;
					}
				}
			}
		}
		// get list elemen
		$rs_id_list = $this->obj_cpd->GetResourceId("GetElemenListByEngine", array($id_engine));
		if($rs_id_list){
			$group_list = "FIND_IN_SET(0, group_elemen_list)";
			while($rec = mysql_fetch_assoc($rs_id_list)){
				$range_value = explode('-', $rec['list_value'], 2);
				if(sizeof($range_value) >= 2){
					$batas_bawah = round($range_value[0], 2);
					$batas_atas = round($range_value[1], 2);
				}else{
					$batas_bawah = 0;
					$batas_atas = 0;
				}	
				if($jumlah >= $batas_bawah AND $jumlah <= $batas_atas){
					$group_list = "FIND_IN_SET(".$rec['id_list'].", group_elemen_list)";
					break;
				}
			}
		}
		$nilai = $this->obj_cpd->GetDataAsSingleArray("GetNilaiSkpByEngine", array($group_list));	
		if(!empty($nilai))
			return $nilai['nilai_skp'];
		else
			return 0;
	}
	
	private function DisplayTabelNilaiSKP(){
		$formulas = 250 / 150;
		// parse data	
		$rs_id = $this->obj_cpd->GetResourceId("GetListRanah", array());
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				// set ranah
				if(!isset($this->arr_ranah_all[$rec['alphabet']])){$this->arr_ranah_all[$rec['alphabet']] = 0;}
				// --
				$this->obj_tmpl->addVar('list_ranah_all', 'ALPHABET', $rec['alphabet']);
				$this->obj_tmpl->addVar('list_ranah_all', 'NAMA', $rec['nama']);
				// skp ikafmi
				$skp_ikafmi = number_format($this->arr_ranah_all[$rec['alphabet']], 2, ',', '');
				$this->obj_tmpl->addVar('list_ranah_all', 'TOTAL', $skp_ikafmi);
				// skp konversi
				$skp_konversi = $this->arr_ranah_all[$rec['alphabet']] * $formulas;
				$skp_konversi = number_format($skp_konversi, 2, ',', '');
				$this->obj_tmpl->addVar('list_ranah_all', 'TOTAL_KONVERSI', $skp_konversi);
				$this->obj_tmpl->ParseTemplate('list_ranah_all', 'a');
			}
		}
		$skp_ikafmi = number_format(array_sum($this->arr_ranah_all), 2, ',', '');
		$this->obj_tmpl->addVar('display', 'TOTAL_NILAI_ALL', $skp_ikafmi);
		$skp_konversi = array_sum($this->arr_ranah_all) * $formulas;
		$skp_konversi = number_format($skp_konversi, 2, ',', '');
		$this->obj_tmpl->addVar('display', 'TOTAL_NILAI_ALL_KONVERSI', $skp_konversi);
	}
}

?>