<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{		
	// object definition
	protected $obj_cpd;
	protected $obj_date;
	// variable
	protected $int_id_kegiatan;
	protected $int_id_form;
	protected $arr_field;
	protected $str_xml;
	protected $arr_detail;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('content');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		/* -- Other object loaded below */
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('kegiatan');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// library loaded
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');
	}
	
	public function PageView(){
		// Display Detail Kegiatan
		self::DisplayDetailKegiatan();
		// get xml data
		self::GetXmlData();
		// Display Elemen Kegiatan
		self::DisplayListElemen();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayDetailKegiatan(){
		// kegiatan
		$params = array($this->arr_routes['params'][0], $this->str_userid);
		$this->arr_detail = $this->obj_cpd->GetDataAsSingleArray("GetDetailKegiatanByIdLog", $params);
		// id form
		$this->int_id_form = $this->arr_detail['id_form'];
		// str xml
		$this->str_xml = $this->arr_detail['data_kegiatan'];
		// parse
		$this->obj_tmpl->addVar('content', 'ID_LOG', $this->arr_detail['id_log']);
		$this->obj_tmpl->addVar('content', 'ID_FORM', $this->arr_detail['id_form']);
		$this->obj_tmpl->addVar('content', 'IS_MANUAL', $this->arr_detail['is_manual']);
		$this->obj_tmpl->addVar('content', 'ID_KEGIATAN', $this->arr_detail['id_kegiatan']);
		$this->obj_tmpl->addVar('content', 'NAMA_KEGIATAN', $this->arr_detail['nama']);
		// get detail form
		$params = array($this->arr_detail['id_form']);
		$result = $this->obj_cpd->GetDataAsSingleArray("GetDetailFormById", $params);
		$this->obj_tmpl->addVar('content', 'DATE_LABEL', $result['date_label']);
		$this->obj_tmpl->addVar('content', 'DATE_LABEL_EN', $result['date_label_en']);
		// --
	}
	
	private function GetXmlData(){
		// field
		if(isset($this->str_xml)){
			$strxml = $this->str_xml;			
			$xml = simplexml_load_string($strxml);
			// echo does the casting for you
			$count = count($xml->item);
			for($i=0;$i<$count;$i++){
				$id = intval($xml->item[$i]->idt);
				$value = strval($xml->item[$i]->value);
				$this->arr_field[$id] = $value;
			}
		}
	}
	
	private function DisplayListElemen(){		
		$params = array($this->int_id_form);
		$rs_id = $this->obj_cpd->GetResourceId("GetDisplayedElemenByIdForm", $params);
		if($rs_id){
			while($rs = mysql_fetch_assoc($rs_id)){
				$this->obj_tmpl->addVar('list_elemen', 'ID', $rs['id_elemen']);
				$this->obj_tmpl->addVar('list_elemen', 'LABEL', $rs['label']);
				$this->obj_tmpl->addVar('list_elemen', 'LABEL_EN', $rs['label_en']);		
				$this->obj_tmpl->addVar('list_elemen', 'VIEW', self::GetElemenView($rs));
				$this->obj_tmpl->ParseTemplate('list_elemen', 'a');
			}
		}
		// display skp manual
		if($this->arr_detail['is_manual'] == 'yes'){
			$this->obj_tmpl->setAttribute('skp_manual', 'visibility', 'show');
		}
		$this->obj_tmpl->addVar('skp_manual', 'NILAI_SKP', $this->arr_detail['nilai_skp']);
		// nilai last input
		if(isset($this->obj_notify->arr_message['field']['NILAI'])){
			$this->obj_tmpl->addVar('skp_manual', 'NILAI_SKP', $this->obj_notify->arr_message['field']['NILAI']);
		}
		// display activities date
		$this->obj_tmpl->addVar('content', 'TANGGAL_KEGIATAN', $this->obj_date->GetFullDate($this->arr_detail['tanggal_kegiatan']));
	}
	
	private function GetElemenView($rs){
		$str_view = "";
		$value = explode(' ', $rs['label'], 2);
		$value = strtoupper($value[0]);
		switch($rs['tipe']){
			case 'text':
				$str_view = $this->arr_field[$rs['id_elemen']];
				break;
			case 'textarea':
				$str_view = $this->arr_field[$rs['id_elemen']];
				break;
			case 'filebrowse':
				$str_view = '';
				// url
				$url = "#";
				// check if last file exists
				$arr_data = $this->obj_cpd->GetDataAsSingleArray("GetDetailedDokumenBukti", array($this->str_userid, $this->arr_field[$rs['id_elemen']]));				
				if(!empty($arr_data)){
					$file = $arr_data['file_path'] . $arr_data['file_name'];
					if(!is_file($file)){
						$str_view .= '<a href="#">File Not Found</a>';
					}else{
						$url = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], 'dokumen', 'download', array(sha1(md5($this->str_userid)), md5(sha1($this->arr_field[$rs['id_elemen']]))));
					$str_view .= '<a href="'.$url.'">'.$arr_data['file_name'].'</a>';
					}	
				}else{
					$str_view .= '<a href="#">File Not Found</a>';
				}
				break;
			case 'radio':
				$rs_id = $this->obj_cpd->GetResourceId("GetElemenListByIdElemen", array($rs['id_elemen']));
				if($rs_id){
					while($rec = mysql_fetch_assoc($rs_id)){
						if($this->arr_field[$rs['id_elemen']] == $rec['list_value']){
							$str_view = $rec['list_name'];
							break;
						}
					}
				}
				break;
			case 'selectbox':
				$rs_id = $this->obj_cpd->GetResourceId("GetElemenListByIdElemen", array($rs['id_elemen']));
				if($rs_id){
					while($rec = mysql_fetch_assoc($rs_id)){
						if($this->arr_field[$rs['id_elemen']] == $rec['list_value']){
							$str_view = $rec['list_name'];
							break;
						}
					}
				}
				break;
			case 'date':
				$str_view = $this->obj_date->GetFullDate($this->arr_field[$rs['id_elemen']]);
				break;
			case 'datetime':
				$str_view = $this->obj_date->GetFullDate($this->arr_field[$rs['id_elemen']]);
				break;
			case 'spt_cabang':
				$str_view = $this->arr_field[$rs['id_elemen']];
				// append
				$this->obj_tmpl->ParseTemplate('list_autocomplete', 'a');		
				break;	
			case 'spt_klinik':
				$str_view = $this->arr_field[$rs['id_elemen']];
				// append
				$this->obj_tmpl->ParseTemplate('list_autocomplete', 'a');
				break;	
			case 'spt_rumkit':
				$str_view = $this->arr_field[$rs['id_elemen']];
				// append
				$this->obj_tmpl->ParseTemplate('list_autocomplete', 'a');
				break;	
			case 'spt_studi':
				$str_view = $this->arr_field[$rs['id_elemen']];
				// append
				$this->obj_tmpl->ParseTemplate('list_autocomplete', 'a');
				break;	
			case 'spt_wilayah':
				$str_view = $this->arr_field[$rs['id_elemen']];
				// append
				$this->obj_tmpl->ParseTemplate('list_autocomplete', 'a');
				break;
			default:
				$str_view = "";
				break;
		}
		return $str_view;
	}
	
	private function CreateElemenDate($id, $time = false){
		// filled
		if(isset($this->arr_field[$id])){
			$tgl = explode(' ', $this->arr_field[$id]);
			$tgl_filled = explode('-', $tgl[0]);
		}else{
			$tgl_filled = array(date('Y'), '01', '01');
		}
		// button
		$button = '<input type="button" value="kalender" onclick="displayCalendarSelectBox(form_input.tahun_'.$id.',form_input.bulan_'.$id.',form_input.day_'.$id.',false,false,this)">'; 
		// tahun 
		$tahun = '<select name="tahun_'.$id.'">';
		for($i=date('Y')-10;$i<=date('Y');$i++){
			if($tgl_filled[0] == $i)
				$selected = 'selected="selected"';
			else
				$selected = '';
			$tahun .= "<option value=\"$i\" $selected>$i</option>";
		}
		$tahun .= '</select>';
		// bulan
		$arr_bln = array('01' => 'Jan', '02' => 'Feb', '03' => 'Mar', '04' => 'Apr', '05' => 'May', '06' => 'Jun', '07' => 'Jul', '08' => 'Ags', '09' => 'Sep', '10' => 'Oct', '11' => 'Nov', '12' => 'Dec');
		$bulan = '<select name="bulan_'.$id.'">';
		foreach($arr_bln as $key => $val){
			if($tgl_filled[1] == $key)
				$selected = 'selected="selected"';
			else
				$selected = '';
			$bulan .= "<option value=\"$key\" $selected>$val</option>";
		}
		$bulan .= '</select>';
		// day
		$day = '<select name="day_'.$id.'">';
		for($i=1;$i<=31;$i++){
			if($tgl_filled[2] == $i)
				$selected = 'selected="selected"';
			else
				$selected = '';
			if($i<10)
					$i = '0' . $i;
			$day .= "<option value=\"$i\" $selected>$i</option>";
		}
		$day .= '</select>';
		//---------------------
		$hour = "";
		$minute = "";
		if($time){
			if(isset($tgl[1]))
				$time_filled = explode(':', $tgl[1]);
			else
				$time_filled = array('00', '00', '00');
			// hour
			$hour = '<select name="hour_'.$id.'">';
			for($i=1;$i<=23;$i++){
				if($time_filled[0] == $i)
					$selected = 'selected="selected"';
				else
					$selected = '';
				if($i<10)
					$i = '0' . $i;
				$hour .= "<option value=\"$i\" $selected>$i</option>";
			}
			$hour .= '</select>';
			// minute
			$minute = '<select name="minute_'.$id.'">';
			$i = 0;
			while($i<=55){
				if($time_filled[1] == $i)
					$selected = 'selected="selected"';
				else
					$selected = '';
				if($i<10)
					$i = '0' . $i;
				$minute .= "<option value=\"$i\" $selected>$i</option>";
				$i = $i + 5;
			}
			$minute .= '</select>';
			// button
			$button = '<input type="button" value="kalender" onclick="displayCalendarSelectBox(form_input.tahun_'.$id.',form_input.bulan_'.$id.',form_input.day_'.$id.',form_input.hour_'.$id.',form_input.minute_'.$id.',this)">'; 
		}
		$str_return = $day . $bulan . $tahun . $hour . $minute;
		$str_return .= $button;
		return $str_return;
	}
}

?>