<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{		
	protected $obj_cpd;
	protected $obj_date;
	// variable definition
	protected $int_periode = '';
	protected $int_tahun = '';
	protected $int_ranah = '';
	protected $str_tgl_mulai;
	protected $str_tgl_selesai;
	protected $arr_tahun_kegiatan = array();
	protected $arr_ranah_all = array();
	protected $total_nilai = 0;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		/* Other object loaded below */
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('evaluasi', 'kegiatan', 'str');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// --
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	
		// load javascript
		$this->obj_ctrl->LoadJavascript('jquery.popin', 'jquery');	
	}
	
	public function PageView(){
		// display variable
		self::DisplayVariable();
		// display str
		self::DisplayDetailSTR();
		// display borang penilaian diri
		self::DisplayBorangPenilaian();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayVariable(){
		// periode
		if(isset($this->arr_routes['params'][0])){
			$this->int_periode = $this->arr_routes['params'][0];
		}
		// tahun
		if(isset($this->arr_routes['params'][1])){
			$this->int_tahun = $this->arr_routes['params'][1];
		}
		// sub link
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'penilaian'));
		$this->obj_tmpl->addVar('content', 'URL_REKAPITULASI', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'evaluasi', array($this->int_periode)));
		$this->obj_tmpl->addVar('content', 'URL_PENILAIAN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'penilaian', array($this->int_periode)));
		$this->obj_tmpl->addVar('content', 'URL_PKB', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'p2kb', array($this->int_periode)));
		$this->obj_tmpl->addVar('content', 'URL_SURAT', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'rekomendasi', array($this->int_periode)));
	}
	
	private function DisplayDetailSTR(){
		$result = $this->obj_cpd->GetDataAsSingleArray("GetDetailPeriodeStrById", array($this->str_userid, $this->int_periode));
		if(!empty($result)){
			$tgl_periode = $this->obj_date->GetFullDate($result['tgl_mulai']) . ' s/d ' .$this->obj_date->GetFullDate($result['tgl_selesai']);
			$this->obj_tmpl->AddVar('content', 'STR_PERIODE', $tgl_periode);
		}else{
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], 'hasil', 'evaluasi');
		}
		// tahun kegiatan
		$rs_id =  $this->obj_cpd->GetResourceId("GetListTahunPeriodeById", array($this->str_userid, $this->int_periode));
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				$this->obj_tmpl->addVar('list_tahun', 'VALUE', $this->int_periode . '/' .$rec['id_tahun_periode'] . '/');
				$lbl = $this->obj_date->GetFullDate($rec['tgl_mulai'], 'ins').' s/d '.$this->obj_date->GetFullDate($rec['tgl_selesai'], 'ins');
				// parse data
				if($this->int_tahun == $rec['id_tahun_periode']){
					$this->obj_tmpl->addVar('list_tahun', 'SELECTED', 'selected="selected"');
					$this->str_tgl_mulai = $rec['tgl_mulai'];
					$this->str_tgl_selesai = $rec['tgl_selesai'];
					// display data
					$this->obj_tmpl->addVar('display', 'view', 'data');
				}else{
					$this->obj_tmpl->addVar('list_tahun', 'SELECTED', '');
				}
				$this->obj_tmpl->addVar('list_tahun', 'TAHUN', $lbl);
				$this->obj_tmpl->ParseTemplate('list_tahun', 'a');
			}
		}
	}
	
	private function DisplayBorangPenilaian(){
		$rs_id = $this->obj_cpd->GetResourceId("GetListRanah", array());
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				$this->obj_tmpl->addVar('list_ranah', 'ALPHABET', $rec['alphabet']);
				$this->obj_tmpl->addVar('list_ranah', 'RANAH', strtoupper($rec['nama']));
				// get list kegiatan
				self::DisplayListKegiatan($rec['id_ranah']);
				// --
				$this->obj_tmpl->parseTemplate('list_ranah', 'a');
			}
		}
	}
	
	private function DisplayListKegiatan($id_ranah){
		$this->total_nilai = 0;
		$formulas = 250/150;
		$no = 1;
		// clear template
		$this->obj_tmpl->clearTemplate('list_kegiatan');
		// parse data
		$rs_id = $this->obj_cpd->GetResourceId("GetListKegiatanByRanah", array($id_ranah));
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				$this->obj_tmpl->addVar('list_kegiatan', 'NO', $no);
				$this->obj_tmpl->addVar('list_kegiatan', 'NAMA_KEGIATAN', $rec['nama']);
				// get buku log
				self::DisplayBukuLog($no, $rec['id_kegiatan']);
				// --
				$this->obj_tmpl->parseTemplate('list_kegiatan', 'a');
				$no++;
			}
		}
		// --
		$skp_ikafmi = number_format($this->total_nilai, 2, ',', '');
		$this->obj_tmpl->addVar('list_ranah', 'SKP_Persatuan Perawat Nasional Indonesia', $skp_ikafmi);
		$skp_konversi = number_format($this->total_nilai * $formulas, 2, ',', '');
		$this->obj_tmpl->addVar('list_ranah', 'SKP_KONVERSI', $skp_konversi);
	}
	
	private function DisplayBukuLog($no, $id_kegiatan){
		$formulas = 250/150;
		// clear template
		$this->obj_tmpl->clearTemplate('list_buku_log');
		// show total rutin
		$this->obj_tmpl->setAttribute('row_rutin', 'visibility', 'hidden');
		// get data
		$params = array($this->str_userid, $id_kegiatan, $this->str_tgl_mulai, $this->str_tgl_selesai);
		$rs_id = $this->obj_cpd->GetResourceId("GetEvaluatedBukuLogByIdKegiatan", $params);
		// parse data
		if($rs_id){
			$sub_no = 1;
			$total = 0;
			while($rec = mysql_fetch_assoc($rs_id)){
				$this->obj_tmpl->addVar('list_buku_log', 'NO', $no);
				$this->obj_tmpl->addVar('list_buku_log', 'SUB_NO', $sub_no);
				// tanggal kegiatan
				$this->obj_tmpl->addVar('list_buku_log', 'DATE_LABEL', $rec['date_label']);
				$this->obj_tmpl->addVar('list_buku_log', 'TANGGAL_KEGIATAN', $this->obj_date->GetFullDate($rec['tanggal_kegiatan']));
				// nilai skp
				if($rec['tipe'] == 'rutin'){
					// rutin = true
					$rutin = true;
					$this->obj_tmpl->addVar('list_buku_log', 'SKP_Persatuan Perawat Nasional Indonesia', '-');
					$this->obj_tmpl->addVar('list_buku_log', 'SKP_KONVERSI', '-');
					$total = self::GetNilaiSkpRutin($rec['id_form']);
					// show total rutin
					$this->obj_tmpl->setAttribute('row_rutin', 'visibility', 'show');
					$skp_ikafmi = number_format($total, 2, ',', '');
					$this->obj_tmpl->addVar('row_rutin', 'SKP_Persatuan Perawat Nasional Indonesia', $skp_ikafmi);
					$skp_konversi = number_format($total * $formulas, 2, ',', '');
					$this->obj_tmpl->addVar('row_rutin', 'SKP_KONVERSI', $skp_konversi);
				}else{
					$total = $rec['nilai_skp'];
					$skp_ikafmi = number_format($total, 2, ',', '');
					$this->obj_tmpl->addVar('list_buku_log', 'SKP_Persatuan Perawat Nasional Indonesia', $skp_ikafmi);
					$skp_konversi = number_format($total * $formulas, 2, ',', '');
					$this->obj_tmpl->addVar('list_buku_log', 'SKP_KONVERSI', $skp_konversi);
					// total nilai
					$this->total_nilai = $this->total_nilai + $total;
				}
				// url detail
				$this->obj_tmpl->addVar('list_buku_log', 'URL_DETAIL', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'penilaian-detail', array($rec['id_log'])));
				// --
				$this->obj_tmpl->ParseTemplate('list_buku_log', 'a');
				$sub_no++;
			}
			// rutin = true
			if(isset($rutin)){
				$this->total_nilai = $this->total_nilai + $total;
			}
		}
	}
	
	private function GetNilaiSkpRutin($id_form){
		$nilai = 0;
		$jumlah = 0;
		// get parameter and indikator
		$arr = $this->obj_cpd->GetDataAsSingleArray("GetParameterAndEngineByForm", array($id_form, $id_form));
		$id_parameter = $arr['parameter'];
		$id_engine = $arr['indikator'];
		// get nilai dalam range tahun kegiatannya
		$rs_id = $this->obj_cpd->GetResourceId("GetDataKegiatanByFormDate", array($this->str_userid, $id_form, $this->str_tgl_mulai, $this->str_tgl_selesai));
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				$arr_field = "";
				$xml = simplexml_load_string($rec["data_kegiatan"]);
				// echo does the casting for you
				$count = count($xml->item);
				for($i=0;$i<$count;$i++){
					$id = intval($xml->item[$i]->idt);
					$value = strval($xml->item[$i]->value);
					if($id == $id_parameter){
						$jumlah = $jumlah + $value;
						break;
					}
				}
			}
		}
		// get list elemen
		$rs_id_list = $this->obj_cpd->GetResourceId("GetElemenListByEngine", array($id_engine));
		if($rs_id_list){
			$group_list = "FIND_IN_SET(0, group_elemen_list)";
			while($rec = mysql_fetch_assoc($rs_id_list)){
				$range_value = explode('-', $rec['list_value'], 2);
				if(sizeof($range_value) >= 2){
					$batas_bawah = round($range_value[0], 2);
					$batas_atas = round($range_value[1], 2);
				}else{
					$batas_bawah = 0;
					$batas_atas = 0;
				}	
				if($jumlah >= $batas_bawah AND $jumlah <= $batas_atas){
					$group_list = "FIND_IN_SET(".$rec['id_list'].", group_elemen_list)";
					break;
				}
			}
		}
		$nilai = $this->obj_cpd->GetDataAsSingleArray("GetNilaiSkpByEngine", array($group_list));	
		if(!empty($nilai))
			return $nilai['nilai_skp'];
		else
			return 0;
	}
	
}

?>