<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	protected $obj_cpd;
	protected $obj_paging;
	protected $obj_date;
	protected $obj_notify;
	// var
	protected $str_keyword;
	protected $str_wilayah;
	protected $arr_wilayah = array();
	protected $arr_kota = array();
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		/* Other object loaded below */
		// load object business
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('wilayah', 'evaluasi');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// --
		// load object pagination
		$this->obj_paging = $this->obj_ctrl->LoadLibrary('PaginationMySQL');
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');	
	}
	
	public function PageView(){
		// display variable
		self::DisplayVariable();		
		// display wilayah
		self::DisplayWilayahAuthority();		
		// display wilayah
		self::DisplayKotaAuthority();	
		// display calon anggota
		self::DisplayListAnggota();
		// display test cookies
		self::DisplayNotification();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayNotification(){
		// get session for start notification
		$this->obj_notify->GetMessage();
		// display message	
		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');
		// last field	
		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');
		// clear session when finish
		$this->obj_notify->ClearSession();
	}
	
	private function DisplayVariable(){
		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));	
		// keyword
		if(isset($_SESSION['search']['penilaian']['nama'])){
			$this->str_keyword = "%" . $_SESSION['search']['penilaian']['nama'] . "%";
			$this->obj_tmpl->addVar('content', 'KEYWORD', $_SESSION['search']['penilaian']['nama']);
		}else{
			$this->str_keyword = "%%";
		}
	}
	
	private function DisplayWilayahAuthority(){
		// cabang
		$wilayah = "";
		if(isset($_SESSION['search']['penilaian']['wilayah'])){ $this->str_wilayah = $_SESSION['search']['penilaian']['wilayah'];}
		// parsing data
		$rs_id = $this->obj_cpd->GetResourceId("GetListWilayah", array());
		if($rs_id){
			while($rs = mysql_fetch_assoc($rs_id)){	
				$this->arr_wilayah[] = $rs['id_wilayah'];
				if($rs['id_wilayah'] == $this->str_wilayah){
					$this->obj_tmpl->addVar('list_wilayah', 'SELECTED', 'selected="selected"');
				}else{
					$this->obj_tmpl->addVar('list_wilayah', 'SELECTED', '');
				}
				$this->obj_tmpl->addVar('list_wilayah', 'VALUE', $rs['id_wilayah']);
				$this->obj_tmpl->addVar('list_wilayah', 'NAMA', $rs['nama']);
				$this->obj_tmpl->ParseTemplate('list_wilayah', 'a');
			}
		}			
		if(empty($this->str_wilayah))
			$this->arr_wilayah = implode(',', $this->arr_wilayah);
		else
			$this->arr_wilayah = $this->str_wilayah;
	}
	
	private function DisplayKotaAuthority(){
		// parsing data
		$rs_id = $this->obj_cpd->GetResourceId("GetListKotaByWilayah", array($this->arr_wilayah));
		if($rs_id){
			while($rs = mysql_fetch_assoc($rs_id)){	
				$this->arr_kota[] = $rs['id_city'];
			}
		}		
		$this->arr_kota = implode(',', $this->arr_kota);
	}
	
	private function DisplayListAnggota(){
		// set parameter pages on index [0]
		if(!isset($this->arr_routes['params'][0]))
			$page = 1;
		else
			$page = $this->arr_routes['params'][0];
		// set active page number
		$this->obj_paging->SetPagesNumber($page);
		// set max record
		$this->obj_paging->SetMaxRecord(20);
		// set total record
		$int_total = $this->obj_cpd->GetDataAsSingleArray("GetTotalAnggotaByTim", array($this->arr_kota, $this->str_keyword));
		$this->obj_paging->SetTotalRecord($int_total['total']);
		// set url
		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));
		// set template
		$this->obj_paging->SetTempatePaging('pagination');
		// parse paging
		$this->obj_paging->ParsePaging();
		// get start record
		$start = $this->obj_paging->int_start_record;
		$max = $this->obj_paging->int_max_record;
		// parsing data
		$rs_id = $this->obj_cpd->GetResourceId("GetListAnggotaByTim", array($this->arr_kota, $this->str_keyword, $start, $max));	
		if($rs_id){
			$no = $start + 1;
			$index = 0;
			while($rs = mysql_fetch_assoc($rs_id)){		
				// url detail
				$url = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'periode', array($rs['id_person']));
				// parse data
				$this->obj_tmpl->addVar('list_data', 'URL_DETAIL', $url);
				$this->obj_tmpl->addVar('list_data', 'NO', $no);
				$this->obj_tmpl->addVar('list_data', 'ID', $rs['id_person']);
				$this->obj_tmpl->addVar('list_data', 'CABANG', $rs['cabang']);
				$this->obj_tmpl->addVar('list_data', 'NAMA', $rs['nama_lengkap']);
				$this->obj_tmpl->addVar('list_data', 'PREFIX', $rs['prefix']);
				$this->obj_tmpl->addVar('list_data', 'SUFFIX', $rs['suffix']);
				$this->obj_tmpl->addVar('list_data', 'NO_ANGGOTA', $rs['no_anggota']);
				$this->obj_tmpl->addVar('list_data', 'ALAMAT', $rs['alamat']);
				$this->obj_tmpl->addVar('list_data', 'KOTA', "<br />" . $rs['kota']);
				$this->obj_tmpl->addVar('list_data', 'WAITING', 0);
				$waiting = $this->obj_cpd->GetDataAsSingleArray("GetTotalWaitingApprovalByPerson", array($rs['id_person']));
				if(!empty($waiting['total'])){
					$this->obj_tmpl->addVar('list_data', 'WAITING', '<b>'.$waiting['total'].'</b>');
				}else{
					$this->obj_tmpl->addVar('list_data', 'WAITING', '0');
				}
				$this->obj_tmpl->ParseTemplate('list_data', 'a');
				$no++;
			}
			$this->obj_tmpl->addVar('content', 'TOTAL_DATA', $index);
		}
	}
}

?>