<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{		
	protected $obj_cpd;
	protected $obj_date;
	// variable definition
	protected $str_person = '';
	protected $int_periode = '';
	protected $str_tgl_mulai;
	protected $str_tgl_selesai;
	protected $arr_ranah_all = array();
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		/* Other object loaded below */
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('evaluasi', 'kegiatan', 'str', 'dokumen');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// --
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	
		// --
		$this->obj_ctrl->LoadJavascript('jquery.ui', 'jquery');	
		$this->obj_ctrl->LoadJavascript('jquery.asmselect', 'jquery');	
		// --
		$this->obj_ctrl->LoadStyle('jquery.asmselect', 'otherstyle');	
	}
	
	public function PageView(){
		// display variable
		self::DisplayVariable();
		// display detail user
		self::DisplayDetailPerson();
		// display status kelayakan
		self::DisplayHasilEvaluasi();
		// display status kelayakan
		self::DisplayKegiatanDianjurkan();
		// display topik dianjurkan
		self::DisplayTopikDianjurkan();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayVariable(){
		// top nav
		$this->obj_tmpl->addVar('content', 'URL_ANGGOTA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'anggota'));
		$this->obj_tmpl->addVar('content', 'URL_DAFTAR', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'periode', array($this->arr_routes['params'][0])));
		// person
		if(isset($this->arr_routes['params'][0])){
			$this->str_person = $this->arr_routes['params'][0];
		}
		// periode
		if(isset($this->arr_routes['params'][1])){
			$this->int_periode = $this->arr_routes['params'][1];
		}
		// top link
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));
		$this->obj_tmpl->addVar('display', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		// sub link
		$this->obj_tmpl->addVar('content', 'URL_REKAPITULASI', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'evaluasi', array($this->str_person, $this->int_periode)));
		$this->obj_tmpl->addVar('content', 'URL_PENILAIAN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'diri', array($this->str_person, $this->int_periode)));
		$this->obj_tmpl->addVar('content', 'URL_PKB', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'p2kb', array($this->str_person, $this->int_periode)));
		$this->obj_tmpl->addVar('content', 'URL_SURAT', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'rekomendasi', array($this->str_person, $this->int_periode)));
	}
	
	private function DisplayDetailPerson(){
		$result = $this->obj_cpd->GetDataAsSingleArray("GetDetailAnggotaByIdPerson", array($this->arr_routes['params'][0]));
		if(!empty($result)){
			$this->obj_tmpl->addVar('display', 'PREFIX', $result['prefix']);
			$this->obj_tmpl->addVar('display', 'SUFFIX', $result['suffix']);
			$this->obj_tmpl->addVar('display', 'NAMA', $result['nama_lengkap']);
			$this->obj_tmpl->addVar('display', 'ALAMAT', $result['alamat']);
			$this->obj_tmpl->addVar('display', 'KOTA', $result['kota']);
			$this->obj_tmpl->addVar('display', 'CABANG', $result['cabang']);
			$this->obj_tmpl->addVar('display', 'NO_ANGGOTA', $result['no_anggota']);
			// display foto
			$path = "doc/person/".$result['id_person']."/foto/".$result['photo'];
			if(is_file($path))
				$this->obj_tmpl->addVar('display', 'FOTO', $path);
			else
				$this->obj_tmpl->addVar('display', 'FOTO', "doc/temp/blank.jpg");
		}
	}
	
	private function DisplayHasilEvaluasi(){
		$result = $this->obj_cpd->GetDataAsSingleArray("GetDetailPeriodeStrById", array($this->str_person, $this->int_periode));
		if(!empty($result)){
			// -
			$this->obj_tmpl->addVar('display', 'ID_PERSON', $this->str_person);
			$this->obj_tmpl->addVar('display', 'ID_PERIODE', $this->int_periode);
			// --
			$this->obj_tmpl->addVar('display', 'view', 'data');
			// --
			$tgl_periode = $this->obj_date->GetFullDate($result['tgl_mulai']) . ' s/d ' .$this->obj_date->GetFullDate($result['tgl_selesai']);
			$this->obj_tmpl->AddVar('display', 'STR_PERIODE', $tgl_periode);
			// --
			if($result['status_evaluasi'] == 'accepted'){
				$this->obj_tmpl->AddVar('display', 'ACCEPTED_SELECTED', 'checked="checked"');
			}
			if($result['status_evaluasi'] == 'rejected'){
				$this->obj_tmpl->AddVar('display', 'REJECTED_SELECTED', 'checked="checked"');
			}
		}else{
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], 'penilaian', 'anggota');
		}
	}
	
	private function DisplayKegiatanDianjurkan(){
		$arr_selected = array();
		// selected kegiatan
		$rs_id = $this->obj_cpd->GetResourceId("GetKegiatanDianjurkanByPeriode", array($this->str_person, $this->int_periode));
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				$arr_selected[] = $rec['id_kegiatan'];
			}
		}
		// list kegiatan
		// selected kegiatan
		$rs_id = $this->obj_cpd->GetResourceId("GetListAllKegiatan", array());
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				if(in_array($rec['id_kegiatan'], $arr_selected)){
					$this->obj_tmpl->addVar('list_kegiatan', 'SELECTED', 'selected="selected"');
				}else{
					$this->obj_tmpl->addVar('list_kegiatan', 'SELECTED', '');
				}
				$this->obj_tmpl->addVar('list_kegiatan', 'ID', $rec['id_kegiatan']);
				$this->obj_tmpl->addVar('list_kegiatan', 'NAMA', $rec['nama']);
				$this->obj_tmpl->parseTemplate('list_kegiatan', 'a');
			}
		}
	}
	
	private function DisplayTopikDianjurkan(){
		$arr_selected = array();
		// selected kegiatan
		$rs_id = $this->obj_cpd->GetResourceId("GetTopikDianjurkanByPeriode", array($this->str_person, $this->int_periode));
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				$arr_selected[] = $rec['topik'];
			}
		}
		// list topik
		// selected topik
		$arr_topik = array('Dermatologi Infeksi', 'Dermatologi Non-Infeksi', 'Dermatologi Alergi-Imunologi', 'Dermatologi Kosmetik', 'Tumor dan Bedah Kulit', 'Infeksi Menular Seksual', 'Kedaruratan Kulit');
		foreach($arr_topik as $topik){
			if(in_array($topik, $arr_selected)){
				$this->obj_tmpl->addVar('list_topik', 'SELECTED', 'selected="selected"');
			}else{
				$this->obj_tmpl->addVar('list_topik', 'SELECTED', '');
			}
			$this->obj_tmpl->addVar('list_topik', 'NAMA', $topik);
			$this->obj_tmpl->parseTemplate('list_topik', 'a');
		}
	}
}

?>