<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	var $obj_cpd;
	var $obj_notify;
	// variable definition
	var $arr_params;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		
	}		
	
	protected function ParseDocumentOutput(){
		/** Redirect result to default page */
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'anggota');	
	}
	
	protected function PageLoad(){ 
		/* -- Other object loaded below */
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('str', 'evaluasi', 'kegiatan');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// --
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
	}
	
	public function PageView(){
		// important to encypte bug post form
		if(isset($_POST['save'])){ 
			$action = array_keys($_POST['save']); 
			$this->arr_params = $_POST;
			unset($_POST);
		}else{
			$action = FALSE;
		}
		// controller to manage process that page requested
		switch($action[0]){
			case 'search_penilaian':
				self::SearchDataByPenilaian();
				break;
			case 'evaluasi':
				self::PersetujuanPeriodeKegiatan();
				break;
			case 'hasil_evaluasi':
				self::EvaluasiKegiatanPKB();
				break;
			case 'insert_surat_rekomendasi':
				self::InsertSuratRekomendasi();
				break;
			case 'update_surat_rekomendasi':
				self::UpdateSuratRekomendasi();
				break;
			default:
				break;
		}
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	// notification method
	private function SendNotification($err, $filled, $msg, $type){
		$this->obj_notify->ClearSession();
		$this->obj_notify->SetHeaderMessage($type, $msg);
		// error send
		foreach($err as $val){
			$this->obj_notify->SetMessage($val);
		}		
		// field value history
		for($i=0;$i<count($filled);$i++){
			$name = array_keys($filled);
			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);
		}
		$this->obj_notify->SentMessage();
	}
	
	// search method
	
	private function SearchDataByPenilaian(){
		$_SESSION['search']['penilaian']['wilayah'] = $this->arr_params['id_wilayah'];
		$_SESSION['search']['penilaian']['nama'] = $this->arr_params['keyword'];
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'anggota');
	}
	
	private function PersetujuanPeriodeKegiatan(){
		// check / validate parameter 
		$err = array();	
		$filled = array();	
		// required
		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>ID Person</strong> not selected'; }
		if(empty($this->arr_params['id_periode'])){ $err[] = '<br /><strong>ID Periode</strong> not selected'; }
		$this->obj_cpd->ProcessingData("HapusPersetujuanEvaluasiPerTahun", array($this->arr_params['id_periode']));
		// processing --------------------------------------------------
		if(empty($err)){
			if(isset($this->arr_params['downcheck'])){
				foreach($this->arr_params['downcheck'] as $id){
					if($this->obj_cpd->ProcessingData("PersetujuanEvaluasiPerTahun", array($id))){
						
					}
				}				
			}
		}
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'evaluasi', array($this->arr_params['id_person'], $this->arr_params['id_periode']));
	}	
	
	private function EvaluasiKegiatanPKB(){
		// check / validate parameter 
		$kelayakan = 'waiting';
		$err = array();	
		$filled = array();	
		// required
		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>ID Person</strong> not selected'; }
		if(empty($this->arr_params['id_periode'])){ $err[] = '<br /><strong>ID Periode</strong> not selected'; }
		if(isset($this->arr_params['kelayakan'])){ $kelayakan = $this->arr_params['kelayakan']; }
		// processing --------------------------------------------------
		if(empty($err)){
			// hapus kegiatan
			$this->obj_cpd->ProcessingData("HapusKegiatanDianjurkanByParams", array($this->arr_params['id_person'], $this->arr_params['id_periode']));
			// hapus topik
			$this->obj_cpd->ProcessingData("HapusTopikDianjurkanByParams", array($this->arr_params['id_person'], $this->arr_params['id_periode']));
			// add kegiatan
			if(isset($this->arr_params['kegiatan']) AND $kelayakan == 'rejected'){
				foreach($this->arr_params['kegiatan'] as $id){
					$this->obj_cpd->ProcessingData("InsertKegiatanDianjurkan", array($this->arr_params['id_periode'], $id));
				}				
			}
			// add topik
			if(isset($this->arr_params['topik']) AND $kelayakan == 'rejected'){
				foreach($this->arr_params['topik'] as $nama){
					$this->obj_cpd->ProcessingData("InsertTopikDianjurkan", array($this->arr_params['id_periode'], $nama));
				}				
			}
			// status selesai
			if($kelayakan == 'accepted'){				
				$this->obj_cpd->ProcessingData("UpdateStatusPKBAnggota", array('yes', $this->arr_params['id_person'], $this->arr_params['id_periode']));		
			}else{
				$this->obj_cpd->ProcessingData("UpdateStatusPKBAnggota", array('no', $this->arr_params['id_person'], $this->arr_params['id_periode']));	
			}
			// update kelayakan
			$this->obj_cpd->ProcessingData("EvaluasiHasilKegiatanPKB", array($kelayakan, $this->arr_params['id_person'], $this->arr_params['id_periode']));
		}
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'p2kb', array($this->arr_params['id_person'], $this->arr_params['id_periode']));
	}
	
	private function InsertSuratRekomendasi(){
		$err = array();	
		$filled = array();	
		// check / validate parameter 
		$tgl_str = $this->arr_params['year'].'-'.$this->arr_params['month'].'-'.$this->arr_params['day'];
		// check parameter input
		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>ID Person</strong> not selected'; }
		if(empty($this->arr_params['id_periode'])){ $err[] = '<br /><strong>ID Periode</strong> not selected'; }
		if(empty($this->arr_params['no_surat'])){ $err[] = '<br /><strong>Nomor Surat</strong> harus diisi'; }
		if(empty($this->arr_params['perihal'])){ $err[] = '<br /><strong>Perihal</strong> harus diisi'; }
		if(empty($this->arr_params['lampiran'])){ $err[] = '<br /><strong>Lampiran</strong> harus diisi'; }
		if(empty($this->arr_params['tmp_terbit'])){ $err[] = '<br /><strong>Tempat terbit</strong> harus diisi'; }
		if(empty($this->arr_params['ketua'])){ $err[] = '<br /><strong>Ketua</strong> harus diisi'; }
		// processing --------------------------------------------------
		if(empty($err)){
			$params = array($this->arr_params['id_periode'], $this->arr_params['no_surat'], $this->arr_params['perihal'], $this->arr_params['lampiran'], $this->arr_params['tmp_terbit'], $tgl_str, $this->arr_params['ketua'], $this->arr_params['downloaded'], $this->arr_params['img']);
			// execute process
			if($this->obj_cpd->ProcessingData("InsertSuratRekomendasi", $params)){
				// notification message				
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
			}else{
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
			}	
		}else{
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			
		}
		// redirect to page error page ------------------------------------
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'rekomendasi', array($this->arr_params['id_person'], $this->arr_params['id_periode']));	
	}	
	
	private function UpdateSuratRekomendasi(){
		$err = array();	
		$filled = array();	
		// check / validate parameter 
		$tgl_str = $this->arr_params['year'].'-'.$this->arr_params['month'].'-'.$this->arr_params['day'];
		// check parameter input
		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>ID Person</strong> not selected'; }
		if(empty($this->arr_params['id_periode'])){ $err[] = '<br /><strong>ID Periode</strong> not selected'; }
		if(empty($this->arr_params['no_surat'])){ $err[] = '<br /><strong>Nomor Surat</strong> harus diisi'; }
		if(empty($this->arr_params['perihal'])){ $err[] = '<br /><strong>Perihal</strong> harus diisi'; }
		if(empty($this->arr_params['lampiran'])){ $err[] = '<br /><strong>Lampiran</strong> harus diisi'; }
		if(empty($this->arr_params['tmp_terbit'])){ $err[] = '<br /><strong>Tempat terbit</strong> harus diisi'; }
		if(empty($this->arr_params['ketua'])){ $err[] = '<br /><strong>Ketua</strong> harus diisi'; }
		// processing --------------------------------------------------
		if(empty($err)){
			$params = array($this->arr_params['no_surat'], $this->arr_params['perihal'], $this->arr_params['lampiran'], $this->arr_params['tmp_terbit'], $tgl_str, $this->arr_params['ketua'], $this->arr_params['downloaded'], $this->arr_params['id_periode']);
			// execute process
			if($this->obj_cpd->ProcessingData("UpdateSuratRekomendasi", $params)){
				// notification message				
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
			}else{
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
			}	
		}else{
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			
		}
		// redirect to page error page ------------------------------------
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'rekomendasi', array($this->arr_params['id_person'], $this->arr_params['id_periode']));	
	}	
}

?>