<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{		
	protected $obj_cpd;
	protected $obj_date;
	protected $obj_notify;
	// variable definition
	protected $int_periode = '';
	protected $str_tgl_mulai;
	protected $str_tgl_selesai;
	protected $arr_ranah_all = array();
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		/* Other object loaded below */
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('evaluasi', 'kegiatan', 'str');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// --
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');	
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');
		// javascript loaded
		$this->obj_ctrl->LoadJavascript('dhtmlgoodies_calendar');
		// dhtmlgoodies_calendar loaded
		$this->obj_ctrl->LoadStyle('dhtmlgoodies_calendar', 'dhtmlgoodies_calendar');
		// dhtmlgoodies_calendar loaded body event
		$this->obj_ctrl->LoadEventOnBody("onload", "SetDhtmlgoodiesPathImages('".HTTPPATH."application/themes/dhtmlgoodies_calendar/img/');");
	}
	
	public function PageView(){
		// display variable
		self::DisplayVariable();
		// display detail user
		self::DisplayDetailPerson();
		// display str
		self::DisplayDetailSTR();
		// display default str
		self::DisplayDefaultSuratRekomendasi();
		// display str
		self::DisplaySuratRekomendasi();
		// display test cookies
		self::DisplayNotification();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayNotification(){
		// get session for start notification
		$this->obj_notify->GetMessage();
		// display message	
		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');
		// display last filled	
		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'display');
		// clear session when finish
		$this->obj_notify->ClearSession();
	}
	
	private function DisplayVariable(){
		// top nav
		$this->obj_tmpl->addVar('content', 'URL_ANGGOTA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'anggota'));
		$this->obj_tmpl->addVar('content', 'URL_DAFTAR', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'periode', array($this->arr_routes['params'][0])));
		// person
		if(isset($this->arr_routes['params'][0])){
			$this->str_person = $this->arr_routes['params'][0];
			$this->obj_tmpl->addVar('content', 'ID_PERSON', $this->str_person);
		}
		// periode
		if(isset($this->arr_routes['params'][1])){
			$this->int_periode = $this->arr_routes['params'][1];
			$this->obj_tmpl->addVar('content', 'ID_PERIODE', $this->int_periode);
		}
		// top link
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));
		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		// sub link
		$this->obj_tmpl->addVar('content', 'URL_REKAPITULASI', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'evaluasi', array($this->str_person, $this->int_periode)));
		$this->obj_tmpl->addVar('content', 'URL_PENILAIAN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'diri', array($this->str_person, $this->int_periode)));
		$this->obj_tmpl->addVar('content', 'URL_PKB', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'p2kb', array($this->str_person, $this->int_periode)));
		$this->obj_tmpl->addVar('content', 'URL_SURAT', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'rekomendasi', array($this->str_person, $this->int_periode)));
		// download
		$this->obj_tmpl->addVar('display', 'URL_DOWNLOAD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], 'surat', 'download', array($this->str_person, $this->int_periode)));
	}
	
	private function DisplayDetailPerson(){
		$result = $this->obj_cpd->GetDataAsSingleArray("GetDetailAnggotaByIdPerson", array($this->arr_routes['params'][0]));
		if(!empty($result)){
			$this->obj_tmpl->addVar('content', 'PREFIX', $result['prefix']);
			$this->obj_tmpl->addVar('content', 'SUFFIX', $result['suffix']);
			$this->obj_tmpl->addVar('content', 'NAMA', $result['nama_lengkap']);
			$this->obj_tmpl->addVar('content', 'ALAMAT', $result['alamat']);
			$this->obj_tmpl->addVar('content', 'KOTA', $result['kota']);
			$this->obj_tmpl->addVar('content', 'CABANG', $result['cabang']);
			$this->obj_tmpl->addVar('content', 'NO_ANGGOTA', $result['no_anggota']);
			// display foto
			$path = "doc/person/".$result['id_person']."/foto/".$result['photo'];
			if(is_file($path))
				$this->obj_tmpl->addVar('content', 'FOTO', $path);
			else
				$this->obj_tmpl->addVar('content', 'FOTO', "doc/temp/blank.jpg");
		}
	}
	
	private function DisplayDetailSTR(){
		$result = $this->obj_cpd->GetDataAsSingleArray("GetDetailPeriodeStrById", array($this->str_person, $this->int_periode));
		if(!empty($result)){
			$tgl_periode = $this->obj_date->GetFullDate($result['tgl_mulai']) . ' s/d ' .$this->obj_date->GetFullDate($result['tgl_selesai']);
			$this->obj_tmpl->AddVar('content', 'STR_PERIODE', $tgl_periode);
		}else{
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], 'penilaian', 'anggota');
		}
	}
	
	private function DisplayDefaultSuratRekomendasi(){
		$result = $this->obj_cpd->GetDataAsSingleArray("GetRekomendasiSetting", array());
		if(!empty($result)){
			$this->obj_tmpl->AddVar('content', 'PERIHAL', $result['perihal']);
			$this->obj_tmpl->AddVar('content', 'LAMPIRAN', $result['lampiran']);
			$this->obj_tmpl->AddVar('content', 'TMP_TERBIT', $result['tempat']);
			$this->obj_tmpl->AddVar('content', 'KETUA', $result['ketua']);
			$this->obj_tmpl->AddVar('content', 'IMG', $result['img']);
		}
	}
	
	private function DisplaySuratRekomendasi(){
		$result=$this->obj_cpd->GetDataAsSingleArray("GetSuratRekomendasiByStr", array($this->str_person, $this->int_periode));
		if(!empty($result)){
			$this->obj_tmpl->AddVar('display', 'view', 'data');
			// edit
			$this->obj_tmpl->AddVar('content', 'ACTION', 'update_surat_rekomendasi');
			// parse data
			$this->obj_tmpl->AddVar('content', 'NOMOR_SURAT', $result['nomor_surat']);
			$this->obj_tmpl->AddVar('content', 'PERIHAL', $result['perihal']);
			$this->obj_tmpl->AddVar('content', 'LAMPIRAN', $result['lampiran']);
			$this->obj_tmpl->AddVar('content', 'TMP_TERBIT', $result['tmp_terbit']);
			$this->obj_tmpl->AddVar('content', 'KETUA', $result['ketua_komisi']);
			$this->obj_tmpl->addVar('content', $result['downloaded'], 'selected="selected"');
			$tgl = explode('-', $result['tgl_terbit']);
			$t = $tgl[0];
			$b = $tgl[1];
			$h = $tgl[2];
			$this->obj_date->SetPatTemplates($this->obj_tmpl);
			$this->obj_date->DhtmlgoodiesStandardDate('list_year', 'list_month', 'list_day', $t, $b, $h, date('Y')-5, date('Y'));
			// --
		}else{
			// add
			$this->obj_tmpl->AddVar('content', 'ACTION', 'insert_surat_rekomendasi');
			$t = date('Y');
			$b = date('m');
			$h = date('d');
			$this->obj_date->SetPatTemplates($this->obj_tmpl);
			$this->obj_date->DhtmlgoodiesStandardDate('list_year', 'list_month', 'list_day', $t, $b, $h, date('Y')-6, date('Y'));
		}
	}
}

?>