<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// variable object
	protected $obj_date;
	protected $obj_cpd;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		/* Other object loaded below */
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('str');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// 
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');
	}
	
	public function PageView(){
		// Variable
		self::DisplayVariable();
		// display detail periode str
		self::DisplayPeriodeStr();
		// display list periode kegiatan
		self::DisplayListTahunKegiatan();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayVariable(){
		// variable
		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'diri', array('add')));
		$this->obj_tmpl->addVar('content', 'URL_LIST', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'diri'));
		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
	}
	
	private function DisplayPeriodeStr(){
		// parse data
		if(isset($this->arr_routes['params'][0]) AND !empty($this->arr_routes['params'][0])){
			$rs = $this->obj_cpd->GetDetailPeriodeStrById(array($this->str_userid, $this->arr_routes['params'][0]));
			if(empty($rs)){
				$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'diri');
			}else{
				$this->obj_tmpl->addVar('content', 'TAHUN_MULAI', $this->obj_date->GetFullDate($rs['tgl_mulai']));
				$this->obj_tmpl->addVar('content', 'TAHUN_SELESAI', $this->obj_date->GetFullDate($rs['tgl_selesai']));
				$this->obj_tmpl->addVar('content', 'MULAI', ucwords($rs['status_mulai']));
				$this->obj_tmpl->addVar('content', 'SELESAI', ucwords($rs['status_selesai']));
				$this->obj_tmpl->addVar('content', 'NO_STR', $rs['no_str']);
			}
		}else{
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'diri');
		}		
	}
	
	private function DisplayListTahunKegiatan(){
		$rs_id = $this->obj_cpd->GetListPeriodeKegiatanById(array($this->arr_routes['params'][0], $this->str_userid));
		$no = 1;
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				$url_detail = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], 'buku', 'log', array($rec['tahun']));
				$this->obj_tmpl->addVar('list_tahun_kegiatan', 'NO', $no);
				$this->obj_tmpl->addVar('list_tahun_kegiatan', 'TGL_MULAI', $this->obj_date->GetFullDate($rec['tgl_mulai']));
				$this->obj_tmpl->addVar('list_tahun_kegiatan', 'TGL_SELESAI', $this->obj_date->GetFullDate($rec['tgl_selesai']));
				$this->obj_tmpl->addVar('list_tahun_kegiatan', 'TAHUN', $rec['tahun']);
				$this->obj_tmpl->addVar('list_tahun_kegiatan', 'EVALUASI', ucwords($rec['status_evaluasi']));
				// evaluasi
				switch($rec['status_evaluasi']){
					case 'accepted':
						$this->obj_tmpl->addVar('list_tahun_kegiatan', 'EVALUASI', 'Telah di evaluasi');
						break;
					case 'rejected':
						$this->obj_tmpl->addVar('list_tahun_kegiatan', 'EVALUASI', 'Di tolak (Perbaikan)');
						break;
					default:
						$this->obj_tmpl->addVar('list_tahun_kegiatan', 'EVALUASI', 'Dalam Proses');
						break;
				}
				// selesai
				if($rec['status_selesai'] == 'yes')
					$this->obj_tmpl->addVar('list_tahun_kegiatan', 'FINISH', 'Telah diselesaikan');
				else
					$this->obj_tmpl->addVar('list_tahun_kegiatan', 'FINISH', 'Tahap Pencatatan');
				$this->obj_tmpl->addVar('list_tahun_kegiatan', 'URL_DETAIL', $url_detail);
				$this->obj_tmpl->ParseTemplate('list_tahun_kegiatan', 'a');
				$no++;
			}
		}
	}
}

?>