<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	protected $obj_cpd;
	protected $obj_paging;
	protected $obj_date;
	// init variable
	private $str_tahun = '';
	private $str_keyword;
	
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		// load object business
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('rekomendasi');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// --
		// load object pagination
		$this->obj_paging = $this->obj_ctrl->LoadLibrary('PaginationMySQL');
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	
	}
	
	public function PageView(){
		// get variable
		self::DisplayVariable();
		// Display tahun
		self::DisplayListTahun();
		// list surat rekomendasi
		self::DisplayListRekomendasi();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayVariable(){
		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], 'evaluasi', 'process'));	
		// tahun 
		if(isset($this->arr_routes['params'][0])){
			$this->str_tahun = $this->arr_routes['params'][0];
		}
		// keyword
		if(isset($_SESSION['search']['rekomendasi']['nama'])){
			$this->str_keyword = "%" . $_SESSION['search']['rekomendasi']['nama'] . "%";
			$this->obj_tmpl->addVar('content', 'KEYWORD', $_SESSION['search']['rekomendasi']['nama']);
		}else{
			$this->str_keyword = "%%";
		}
	}
	
	private function DisplayListTahun(){
		$result = $this->obj_cpd->GetDataAsSingleArray("GetTahunListRekomendasi", array());
		if(!empty($result['tahun_awal']) AND !empty($result['tahun_akhir'])){
			for($i=$result['tahun_awal'];$i<=$result['tahun_akhir'];$i++){
				if($i == $this->str_tahun){
					$this->obj_tmpl->addVar('list_tahun', 'SELECTED', 'selected="selected"');
				}else{
					$this->obj_tmpl->addVar('list_tahun', 'SELECTED', '');
				}
				$this->obj_tmpl->addVar('list_tahun', 'TAHUN', $i);
				$this->obj_tmpl->parseTemplate('list_tahun', 'a');
			}		
		}else{
			$this->obj_tmpl->setAttribute('list_tahun', 'visibility', 'hidden');
		}
		// str tahun
		if(!empty($this->str_tahun)){
			$this->str_tahun = "AND YEAR(b.tgl_selesai) = ".$this->str_tahun;
		}
	}
	
	private function DisplayListRekomendasi(){
		// set parameter pages on index [0]
		if(!isset($this->arr_routes['params'][0]))
			$page = 1;
		else
			$page = $this->arr_routes['params'][0];
		// set active page number
		$this->obj_paging->SetPagesNumber($page);
		// set max record
		$this->obj_paging->SetMaxRecord(20);
		// set total record
		$int_total = $this->obj_cpd->GetDataAsSingleArray("GetTotalRekomendasiByParam", array($this->str_keyword, $this->str_tahun));
		$this->obj_paging->SetTotalRecord($int_total['total']);
		// set url
		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));
		// set template
		$this->obj_paging->SetTempatePaging('pagination');
		// parse paging
		$this->obj_paging->ParsePaging();
		// get start record
		$start = $this->obj_paging->int_start_record;
		$max = $this->obj_paging->int_max_record;
		// parsing data
		$rs_id = $this->obj_cpd->GetResourceId("GetListRekomendasiByLimit", array($this->str_keyword, $this->str_tahun, $start, $max));	
		if($rs_id){
			$no = $start + 1;
			while($rec = mysql_fetch_assoc($rs_id)){		
				// url detail
				$url = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], 'surat', 'download', array($rec['id_person'], $rec['id_periode']));
				// parse data
				$this->obj_tmpl->addVar('list_rekomendasi', 'URL_DOWNLOAD', $url);
				$this->obj_tmpl->addVar('list_rekomendasi', 'NO', $no);
				$this->obj_tmpl->addVar('list_rekomendasi', 'NAMA', $rec['nama_lengkap']);
				$this->obj_tmpl->addVar('list_rekomendasi', 'NO_ANGGOTA', $rec['no_anggota']);
				$tgl_periode = $this->obj_date->GetFullDate($rec['tgl_mulai']) . ' s/d ' .$this->obj_date->GetFullDate($rec['tgl_selesai']);
				$this->obj_tmpl->addVar('list_rekomendasi', 'PERIODE', $tgl_periode);
				$this->obj_tmpl->parseTemplate('list_rekomendasi', 'a');
				$no++;
			}
		}
	}
}

?>