<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_cpd;
	protected $obj_date;
	// variable definition
	protected $str_keyword;
	protected $str_wilayah;
	protected $arr_wilayah = array();
	protected $arr_kota = array();
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		/* -- Other object loaded below */
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('wilayah', 'str');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// --
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');			
	}
	
	public function PageView(){
		// Variable
		self::DisplayVariable();
		// display List Kegiatan
		self::DisplayListPeriode();				
		// display wilayah
		self::DisplayWilayahAuthority();		
		// display wilayah
		self::DisplayKotaAuthority();	
		// display detail user
		self::DisplayDetailPerson();	
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayVariable(){
		// variable
		$this->obj_tmpl->addVar('content', 'URL_ANGGOTA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'dokumen-anggota'));
	}
	
	private function DisplayListPeriode(){
		$rs_id = $this->obj_cpd->GetResourceId("GetListPeriodeStrByIdPerson", array($this->arr_routes['params'][0]));
		if($rs_id){
			$no = 1;
			while($rec = mysql_fetch_assoc($rs_id)){
				$url_detail = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'dokumen', array($this->arr_routes['params'][0], $rec['id_periode']));
				$this->obj_tmpl->addVar('list_tahun_periode', 'NO', $no);
				$this->obj_tmpl->addVar('list_tahun_periode', 'NO_STR', $rec['no_str']);
				$this->obj_tmpl->addVar('list_tahun_periode', 'TGL_MULAI', $this->obj_date->GetFullDate($rec['tgl_mulai']));
				$this->obj_tmpl->addVar('list_tahun_periode', 'TGL_SELESAI', $this->obj_date->GetFullDate($rec['tgl_selesai']));
				$this->obj_tmpl->addVar('list_tahun_periode', 'MULAI', ucwords($rec['status_mulai']));
				$this->obj_tmpl->addVar('list_tahun_periode', 'SELESAI', ucwords($rec['status_selesai']));
				$this->obj_tmpl->addVar('list_tahun_periode', 'URL_DETAIL', $url_detail);
				$this->obj_tmpl->ParseTemplate('list_tahun_periode', 'a');
				$no++;
			}		
		}
	}
	
	// authority
	
	private function DisplayWilayahAuthority(){
		// cabang
		$wilayah = "";
		if(isset($_SESSION['search']['wilayah'])){ $this->str_wilayah = $_SESSION['search']['wilayah'];}
		// parsing data
		$rs_id = $this->obj_cpd->GetResourceId("GetListWilayahByTim", array($this->str_userid));		
		if($rs_id){
			while($rs = mysql_fetch_assoc($rs_id)){	
				$this->arr_wilayah[] = $rs['id_wilayah'];
			}
		}
		if(empty($this->str_wilayah))
			$this->arr_wilayah = implode(',', $this->arr_wilayah);
		else
			$this->arr_wilayah = $this->str_wilayah;
	}
	
	private function DisplayKotaAuthority(){
		// parsing data
		$rs_id = $this->obj_cpd->GetResourceId("GetListKotaByWilayah", array($this->arr_wilayah));		
		if($rs_id){
			while($rs = mysql_fetch_assoc($rs_id)){	
				$this->arr_kota[] = $rs['id_city'];
			}
		}
	}
	
	private function DisplayDetailPerson(){
		$result = $this->obj_cpd->GetDataAsSingleArray("GetDetailAnggotaByIdPerson", array($this->arr_routes['params'][0]));
		if(!empty($result)){
			if(!in_array($result['id_city'], $this->arr_kota)){
				$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'anggota');	
			}else{
				$this->obj_tmpl->addVar('content', 'PREFIX', $result['prefix']);
				$this->obj_tmpl->addVar('content', 'SUFFIX', $result['suffix']);
				$this->obj_tmpl->addVar('content', 'NAMA_LENGKAP', $result['nama_lengkap']);
				$this->obj_tmpl->addVar('content', 'ALAMAT', $result['alamat']);
				$this->obj_tmpl->addVar('content', 'KOTA', $result['kota']);
				$this->obj_tmpl->addVar('content', 'CABANG', $result['cabang']);
				$this->obj_tmpl->addVar('content', 'NO_ANGGOTA', $result['no_anggota']);
				// display foto
				$path = "doc/person/".$result['id_person']."/foto/".$result['photo'];
				if(is_file($path))
					$this->obj_tmpl->addVar('content', 'FOTO', $path);
				else
					$this->obj_tmpl->addVar('content', 'FOTO', "doc/temp/blank.jpg");
			}
		}else{
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'anggota');	
		}
	}
	
}

?>